# mattermost_api
There is also a work-in-progress [Postman API reference](https://documenter.getpostman.com/view/4508214/RW8FERUn).


This Dart package is automatically generated by code originally from the
[OpenAPI Generator](https://openapi-generator.tech) project, and custom templates.


- API version: 4.0.0
- Build package: org.openapitools.codegen.languages.DartClientCodegen


## Example

```dart
import 'package:mattermost_api/api.dart';


// TODO: Set up the client
// Configure client with HTTP Bearer authorization and string token:
// client = MattermostApiClient(
//   basePath: 'https://your-server.tld/api/v4',
//   authentication: MattermostHttpBearerAuthentication('YOUR TOKEN'),
// );
// Configure client with HTTP Bearer authorization and function returning a string:
// client = MattermostApiClient(
//   basePath: 'https://your-server.tld/api/v4',
//   authentication: MattermostHttpBearerAuthentication(()=>'ACCESS TOKEN FROM FUNCTION'),
// );

// Then, access MattermostAuthenticationApi api instance
// final MattermostAuthenticationApi api_instance = client.authentication

final mattermostMigrateAuthToLdapRequest = MattermostMigrateAuthToLdapRequest(); // MattermostMigrateAuthToLdapRequest | 

try {
    await client.authentication.migrateAuthToLdap(mattermostMigrateAuthToLdapRequest);
} catch (e) {
    print('Exception when calling MattermostAuthenticationApi->migrateAuthToLdap: $e\n');
}

```

## Documentation for API Endpoints

All URIs are relative to *http://your-mattermost-url.com/api/v4*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*MattermostAuthenticationApi* | [**migrateAuthToLdap**](doc//MattermostAuthenticationApi.md#migrateauthtoldap) | **POST** /users/migrate_auth/ldap | Migrate user accounts authentication type to LDAP.
*MattermostAuthenticationApi* | [**migrateAuthToSaml**](doc//MattermostAuthenticationApi.md#migrateauthtosaml) | **POST** /users/migrate_auth/saml | Migrate user accounts authentication type to SAML.
*MattermostBleveApi* | [**purgeBleveIndexes**](doc//MattermostBleveApi.md#purgebleveindexes) | **POST** /bleve/purge_indexes | Purge all Bleve indexes
*MattermostBotsApi* | [**assignBot**](doc//MattermostBotsApi.md#assignbot) | **POST** /bots/{bot_user_id}/assign/{user_id} | Assign a bot to a user
*MattermostBotsApi* | [**convertBotToUser**](doc//MattermostBotsApi.md#convertbottouser) | **POST** /bots/{bot_user_id}/convert_to_user | Convert a bot into a user
*MattermostBotsApi* | [**convertUserToBot**](doc//MattermostBotsApi.md#convertusertobot) | **POST** /users/{user_id}/convert_to_bot | Convert a user into a bot
*MattermostBotsApi* | [**createBot**](doc//MattermostBotsApi.md#createbot) | **POST** /bots | Create a bot
*MattermostBotsApi* | [**deleteBotIconImage**](doc//MattermostBotsApi.md#deleteboticonimage) | **DELETE** /bots/{bot_user_id}/icon | Delete bot's LHS icon image
*MattermostBotsApi* | [**disableBot**](doc//MattermostBotsApi.md#disablebot) | **POST** /bots/{bot_user_id}/disable | Disable a bot
*MattermostBotsApi* | [**enableBot**](doc//MattermostBotsApi.md#enablebot) | **POST** /bots/{bot_user_id}/enable | Enable a bot
*MattermostBotsApi* | [**getBot**](doc//MattermostBotsApi.md#getbot) | **GET** /bots/{bot_user_id} | Get a bot
*MattermostBotsApi* | [**getBotIconImage**](doc//MattermostBotsApi.md#getboticonimage) | **GET** /bots/{bot_user_id}/icon | Get bot's LHS icon
*MattermostBotsApi* | [**getBots**](doc//MattermostBotsApi.md#getbots) | **GET** /bots | Get bots
*MattermostBotsApi* | [**patchBot**](doc//MattermostBotsApi.md#patchbot) | **PUT** /bots/{bot_user_id} | Patch a bot
*MattermostBotsApi* | [**setBotIconImage**](doc//MattermostBotsApi.md#setboticonimage) | **POST** /bots/{bot_user_id}/icon | Set bot's LHS icon image
*MattermostBrandApi* | [**deleteBrandImage**](doc//MattermostBrandApi.md#deletebrandimage) | **DELETE** /brand/image | Delete current brand image
*MattermostBrandApi* | [**getBrandImage**](doc//MattermostBrandApi.md#getbrandimage) | **GET** /brand/image | Get brand image
*MattermostBrandApi* | [**uploadBrandImage**](doc//MattermostBrandApi.md#uploadbrandimage) | **POST** /brand/image | Upload brand image
*MattermostChannelsApi* | [**addChannelMember**](doc//MattermostChannelsApi.md#addchannelmember) | **POST** /channels/{channel_id}/members | Add user to channel
*MattermostChannelsApi* | [**autocompleteChannelsForTeam**](doc//MattermostChannelsApi.md#autocompletechannelsforteam) | **GET** /teams/{team_id}/channels/autocomplete | Autocomplete channels
*MattermostChannelsApi* | [**autocompleteChannelsForTeamForSearch**](doc//MattermostChannelsApi.md#autocompletechannelsforteamforsearch) | **GET** /teams/{team_id}/channels/search_autocomplete | Autocomplete channels for search
*MattermostChannelsApi* | [**channelMembersMinusGroupMembers**](doc//MattermostChannelsApi.md#channelmembersminusgroupmembers) | **GET** /channels/{channel_id}/members_minus_group_members | Channel members minus group members.
*MattermostChannelsApi* | [**createChannel**](doc//MattermostChannelsApi.md#createchannel) | **POST** /channels | Create a channel
*MattermostChannelsApi* | [**createDirectChannel**](doc//MattermostChannelsApi.md#createdirectchannel) | **POST** /channels/direct | Create a direct message channel
*MattermostChannelsApi* | [**createGroupChannel**](doc//MattermostChannelsApi.md#creategroupchannel) | **POST** /channels/group | Create a group message channel
*MattermostChannelsApi* | [**createSidebarCategoryForTeamForUser**](doc//MattermostChannelsApi.md#createsidebarcategoryforteamforuser) | **POST** /users/{user_id}/teams/{team_id}/channels/categories | Create user's sidebar category
*MattermostChannelsApi* | [**deleteChannel**](doc//MattermostChannelsApi.md#deletechannel) | **DELETE** /channels/{channel_id} | Delete a channel
*MattermostChannelsApi* | [**getAllChannels**](doc//MattermostChannelsApi.md#getallchannels) | **GET** /channels | Get a list of all channels
*MattermostChannelsApi* | [**getChannel**](doc//MattermostChannelsApi.md#getchannel) | **GET** /channels/{channel_id} | Get a channel
*MattermostChannelsApi* | [**getChannelByName**](doc//MattermostChannelsApi.md#getchannelbyname) | **GET** /teams/{team_id}/channels/name/{channel_name} | Get a channel by name
*MattermostChannelsApi* | [**getChannelByNameForTeamName**](doc//MattermostChannelsApi.md#getchannelbynameforteamname) | **GET** /teams/name/{team_name}/channels/name/{channel_name} | Get a channel by name and team name
*MattermostChannelsApi* | [**getChannelMember**](doc//MattermostChannelsApi.md#getchannelmember) | **GET** /channels/{channel_id}/members/{user_id} | Get channel member
*MattermostChannelsApi* | [**getChannelMemberCountsByGroup**](doc//MattermostChannelsApi.md#getchannelmembercountsbygroup) | **GET** /channels/{channel_id}/member_counts_by_group | Channel members counts for each group that has atleast one member in the channel
*MattermostChannelsApi* | [**getChannelMembers**](doc//MattermostChannelsApi.md#getchannelmembers) | **GET** /channels/{channel_id}/members | Get channel members
*MattermostChannelsApi* | [**getChannelMembersByIds**](doc//MattermostChannelsApi.md#getchannelmembersbyids) | **POST** /channels/{channel_id}/members/ids | Get channel members by ids
*MattermostChannelsApi* | [**getChannelMembersForUser**](doc//MattermostChannelsApi.md#getchannelmembersforuser) | **GET** /users/{user_id}/teams/{team_id}/channels/members | Get channel memberships and roles for a user
*MattermostChannelsApi* | [**getChannelMembersTimezones**](doc//MattermostChannelsApi.md#getchannelmemberstimezones) | **GET** /channels/{channel_id}/timezones | Get timezones in a channel
*MattermostChannelsApi* | [**getChannelModerations**](doc//MattermostChannelsApi.md#getchannelmoderations) | **GET** /channels/{channel_id}/moderations | Get information about channel's moderation.
*MattermostChannelsApi* | [**getChannelStats**](doc//MattermostChannelsApi.md#getchannelstats) | **GET** /channels/{channel_id}/stats | Get channel statistics
*MattermostChannelsApi* | [**getChannelUnread**](doc//MattermostChannelsApi.md#getchannelunread) | **GET** /users/{user_id}/channels/{channel_id}/unread | Get unread messages
*MattermostChannelsApi* | [**getChannelsForTeamForUser**](doc//MattermostChannelsApi.md#getchannelsforteamforuser) | **GET** /users/{user_id}/teams/{team_id}/channels | Get channels for user
*MattermostChannelsApi* | [**getChannelsForUser**](doc//MattermostChannelsApi.md#getchannelsforuser) | **GET** /users/{user_id}/channels | Get all channels from all teams
*MattermostChannelsApi* | [**getDeletedChannelsForTeam**](doc//MattermostChannelsApi.md#getdeletedchannelsforteam) | **GET** /teams/{team_id}/channels/deleted | Get deleted channels
*MattermostChannelsApi* | [**getPinnedPosts**](doc//MattermostChannelsApi.md#getpinnedposts) | **GET** /channels/{channel_id}/pinned | Get a channel's pinned posts
*MattermostChannelsApi* | [**getPrivateChannelsForTeam**](doc//MattermostChannelsApi.md#getprivatechannelsforteam) | **GET** /teams/{team_id}/channels/private | Get private channels
*MattermostChannelsApi* | [**getPublicChannelsByIdsForTeam**](doc//MattermostChannelsApi.md#getpublicchannelsbyidsforteam) | **POST** /teams/{team_id}/channels/ids | Get a list of channels by ids
*MattermostChannelsApi* | [**getPublicChannelsForTeam**](doc//MattermostChannelsApi.md#getpublicchannelsforteam) | **GET** /teams/{team_id}/channels | Get public channels
*MattermostChannelsApi* | [**getSidebarCategoriesForTeamForUser**](doc//MattermostChannelsApi.md#getsidebarcategoriesforteamforuser) | **GET** /users/{user_id}/teams/{team_id}/channels/categories | Get user's sidebar categories
*MattermostChannelsApi* | [**getSidebarCategoryForTeamForUser**](doc//MattermostChannelsApi.md#getsidebarcategoryforteamforuser) | **GET** /users/{user_id}/teams/{team_id}/channels/categories/{category_id} | Get sidebar category
*MattermostChannelsApi* | [**getSidebarCategoryOrderForTeamForUser**](doc//MattermostChannelsApi.md#getsidebarcategoryorderforteamforuser) | **GET** /users/{user_id}/teams/{team_id}/channels/categories/order | Get user's sidebar category order
*MattermostChannelsApi* | [**moveChannel**](doc//MattermostChannelsApi.md#movechannel) | **POST** /channels/{channel_id}/move | Move a channel
*MattermostChannelsApi* | [**patchChannel**](doc//MattermostChannelsApi.md#patchchannel) | **PUT** /channels/{channel_id}/patch | Patch a channel
*MattermostChannelsApi* | [**patchChannelModerations**](doc//MattermostChannelsApi.md#patchchannelmoderations) | **PUT** /channels/{channel_id}/moderations/patch | Update a channel's moderation settings.
*MattermostChannelsApi* | [**removeSidebarCategoryForTeamForUser**](doc//MattermostChannelsApi.md#removesidebarcategoryforteamforuser) | **DELETE** /users/{user_id}/teams/{team_id}/channels/categories/{category_id} | Delete sidebar category
*MattermostChannelsApi* | [**removeUserFromChannel**](doc//MattermostChannelsApi.md#removeuserfromchannel) | **DELETE** /channels/{channel_id}/members/{user_id} | Remove user from channel
*MattermostChannelsApi* | [**restoreChannel**](doc//MattermostChannelsApi.md#restorechannel) | **POST** /channels/{channel_id}/restore | Restore a channel
*MattermostChannelsApi* | [**searchAllChannels**](doc//MattermostChannelsApi.md#searchallchannels) | **POST** /channels/search | Search all private and open type channels across all teams
*MattermostChannelsApi* | [**searchArchivedChannels**](doc//MattermostChannelsApi.md#searcharchivedchannels) | **POST** /teams/{team_id}/channels/search_archived | Search archived channels
*MattermostChannelsApi* | [**searchChannels**](doc//MattermostChannelsApi.md#searchchannels) | **POST** /teams/{team_id}/channels/search | Search channels
*MattermostChannelsApi* | [**searchGroupChannels**](doc//MattermostChannelsApi.md#searchgroupchannels) | **POST** /channels/group/search | Search Group Channels
*MattermostChannelsApi* | [**updateChannel**](doc//MattermostChannelsApi.md#updatechannel) | **PUT** /channels/{channel_id} | Update a channel
*MattermostChannelsApi* | [**updateChannelMemberSchemeRoles**](doc//MattermostChannelsApi.md#updatechannelmemberschemeroles) | **PUT** /channels/{channel_id}/members/{user_id}/schemeRoles | Update the scheme-derived roles of a channel member.
*MattermostChannelsApi* | [**updateChannelNotifyProps**](doc//MattermostChannelsApi.md#updatechannelnotifyprops) | **PUT** /channels/{channel_id}/members/{user_id}/notify_props | Update channel notifications
*MattermostChannelsApi* | [**updateChannelPrivacy**](doc//MattermostChannelsApi.md#updatechannelprivacy) | **PUT** /channels/{channel_id}/privacy | Update channel's privacy
*MattermostChannelsApi* | [**updateChannelRoles**](doc//MattermostChannelsApi.md#updatechannelroles) | **PUT** /channels/{channel_id}/members/{user_id}/roles | Update channel roles
*MattermostChannelsApi* | [**updateChannelScheme**](doc//MattermostChannelsApi.md#updatechannelscheme) | **PUT** /channels/{channel_id}/scheme | Set a channel's scheme
*MattermostChannelsApi* | [**updateSidebarCategoriesForTeamForUser**](doc//MattermostChannelsApi.md#updatesidebarcategoriesforteamforuser) | **PUT** /users/{user_id}/teams/{team_id}/channels/categories | Update user's sidebar categories
*MattermostChannelsApi* | [**updateSidebarCategoryForTeamForUser**](doc//MattermostChannelsApi.md#updatesidebarcategoryforteamforuser) | **PUT** /users/{user_id}/teams/{team_id}/channels/categories/{category_id} | Update sidebar category
*MattermostChannelsApi* | [**updateSidebarCategoryOrderForTeamForUser**](doc//MattermostChannelsApi.md#updatesidebarcategoryorderforteamforuser) | **PUT** /users/{user_id}/teams/{team_id}/channels/categories/order | Update user's sidebar category order
*MattermostChannelsApi* | [**viewChannel**](doc//MattermostChannelsApi.md#viewchannel) | **POST** /channels/members/{user_id}/view | View channel
*MattermostCloudApi* | [**confirmCustomerPayment**](doc//MattermostCloudApi.md#confirmcustomerpayment) | **POST** /cloud/payment/confirm | Completes the payment setup intent
*MattermostCloudApi* | [**createCustomerPayment**](doc//MattermostCloudApi.md#createcustomerpayment) | **POST** /cloud/payment | Create a customer setup payment intent
*MattermostCloudApi* | [**getCloudCustomer**](doc//MattermostCloudApi.md#getcloudcustomer) | **GET** /cloud/customer | Get cloud customer
*MattermostCloudApi* | [**getCloudLimits**](doc//MattermostCloudApi.md#getcloudlimits) | **GET** /cloud/limits | Get cloud workspace limits
*MattermostCloudApi* | [**getCloudProducts**](doc//MattermostCloudApi.md#getcloudproducts) | **GET** /cloud/products | Get cloud products
*MattermostCloudApi* | [**getInvoiceForSubscriptionAsPdf**](doc//MattermostCloudApi.md#getinvoiceforsubscriptionaspdf) | **GET** /cloud/subscription/invoices/{invoice_id}/pdf | Get cloud invoice PDF
*MattermostCloudApi* | [**getInvoicesForSubscription**](doc//MattermostCloudApi.md#getinvoicesforsubscription) | **GET** /cloud/subscription/invoices | Get cloud subscription invoices
*MattermostCloudApi* | [**getSubscription**](doc//MattermostCloudApi.md#getsubscription) | **GET** /cloud/subscription | Get cloud subscription
*MattermostCloudApi* | [**getSubscriptionStats**](doc//MattermostCloudApi.md#getsubscriptionstats) | **GET** /cloud/subscription/stats | GET endpoint for cloud subscription stats
*MattermostCloudApi* | [**postEndpointForCwsWebhooks**](doc//MattermostCloudApi.md#postendpointforcwswebhooks) | **POST** /cloud/webhook | POST endpoint for CWS Webhooks
*MattermostCloudApi* | [**sendAdminUpgradeRequestEmail**](doc//MattermostCloudApi.md#sendadminupgraderequestemail) | **POST** /cloud/subscription/limitreached/invite | POST endpoint for triggering sending emails to admin with request to upgrade workspace
*MattermostCloudApi* | [**sendAdminUpgradeRequestEmailOnJoin**](doc//MattermostCloudApi.md#sendadminupgraderequestemailonjoin) | **POST** /cloud/subscription/limitreached/join | POST endpoint for triggering sending emails to admin with request to upgrade workspace
*MattermostCloudApi* | [**updateCloudCustomer**](doc//MattermostCloudApi.md#updatecloudcustomer) | **PUT** /cloud/customer | Update cloud customer
*MattermostCloudApi* | [**updateCloudCustomerAddress**](doc//MattermostCloudApi.md#updatecloudcustomeraddress) | **PUT** /cloud/customer/address | Update cloud customer address
*MattermostClusterApi* | [**getClusterStatus**](doc//MattermostClusterApi.md#getclusterstatus) | **GET** /cluster/status | Get cluster status
*MattermostCommandsApi* | [**createCommand**](doc//MattermostCommandsApi.md#createcommand) | **POST** /commands | Create a command
*MattermostCommandsApi* | [**deleteCommand**](doc//MattermostCommandsApi.md#deletecommand) | **DELETE** /commands/{command_id} | Delete a command
*MattermostCommandsApi* | [**executeCommand**](doc//MattermostCommandsApi.md#executecommand) | **POST** /commands/execute | Execute a command
*MattermostCommandsApi* | [**getCommandById**](doc//MattermostCommandsApi.md#getcommandbyid) | **GET** /commands/{command_id} | Get a command
*MattermostCommandsApi* | [**listAutocompleteCommands**](doc//MattermostCommandsApi.md#listautocompletecommands) | **GET** /teams/{team_id}/commands/autocomplete | List autocomplete commands
*MattermostCommandsApi* | [**listCommandAutocompleteSuggestions**](doc//MattermostCommandsApi.md#listcommandautocompletesuggestions) | **GET** /teams/{team_id}/commands/autocomplete_suggestions | List commands' autocomplete data
*MattermostCommandsApi* | [**listCommands**](doc//MattermostCommandsApi.md#listcommands) | **GET** /commands | List commands for a team
*MattermostCommandsApi* | [**moveCommand**](doc//MattermostCommandsApi.md#movecommand) | **PUT** /commands/{command_id}/move | Move a command
*MattermostCommandsApi* | [**regenCommandToken**](doc//MattermostCommandsApi.md#regencommandtoken) | **PUT** /commands/{command_id}/regen_token | Generate a new token
*MattermostCommandsApi* | [**updateCommand**](doc//MattermostCommandsApi.md#updatecommand) | **PUT** /commands/{command_id} | Update a command
*MattermostComplianceApi* | [**createComplianceReport**](doc//MattermostComplianceApi.md#createcompliancereport) | **POST** /compliance/reports | Create report
*MattermostComplianceApi* | [**downloadComplianceReport**](doc//MattermostComplianceApi.md#downloadcompliancereport) | **GET** /compliance/reports/{report_id}/download | Download a report
*MattermostComplianceApi* | [**getComplianceReport**](doc//MattermostComplianceApi.md#getcompliancereport) | **GET** /compliance/reports/{report_id} | Get a report
*MattermostComplianceApi* | [**getComplianceReports**](doc//MattermostComplianceApi.md#getcompliancereports) | **GET** /compliance/reports | Get reports
*MattermostDataRetentionApi* | [**addChannelsToRetentionPolicy**](doc//MattermostDataRetentionApi.md#addchannelstoretentionpolicy) | **POST** /data_retention/policies/{policy_id}/channels | Add channels to a granular data retention policy
*MattermostDataRetentionApi* | [**addTeamsToRetentionPolicy**](doc//MattermostDataRetentionApi.md#addteamstoretentionpolicy) | **POST** /data_retention/policies/{policy_id}/teams | Add teams to a granular data retention policy
*MattermostDataRetentionApi* | [**createDataRetentionPolicy**](doc//MattermostDataRetentionApi.md#createdataretentionpolicy) | **POST** /data_retention/policies | Create a new granular data retention policy
*MattermostDataRetentionApi* | [**deleteDataRetentionPolicy**](doc//MattermostDataRetentionApi.md#deletedataretentionpolicy) | **DELETE** /data_retention/policies/{policy_id} | Delete a granular data retention policy
*MattermostDataRetentionApi* | [**getChannelPoliciesForUser**](doc//MattermostDataRetentionApi.md#getchannelpoliciesforuser) | **GET** /users/{user_id}/data_retention/channel_policies | Get the policies which are applied to a user's channels
*MattermostDataRetentionApi* | [**getChannelsForRetentionPolicy**](doc//MattermostDataRetentionApi.md#getchannelsforretentionpolicy) | **GET** /data_retention/policies/{policy_id}/channels | Get the channels for a granular data retention policy
*MattermostDataRetentionApi* | [**getDataRetentionPolicies**](doc//MattermostDataRetentionApi.md#getdataretentionpolicies) | **GET** /data_retention/policies | Get the granular data retention policies
*MattermostDataRetentionApi* | [**getDataRetentionPoliciesCount**](doc//MattermostDataRetentionApi.md#getdataretentionpoliciescount) | **GET** /data_retention/policies_count | Get the number of granular data retention policies
*MattermostDataRetentionApi* | [**getDataRetentionPolicy**](doc//MattermostDataRetentionApi.md#getdataretentionpolicy) | **GET** /data_retention/policy | Get the global data retention policy
*MattermostDataRetentionApi* | [**getDataRetentionPolicyByID**](doc//MattermostDataRetentionApi.md#getdataretentionpolicybyid) | **GET** /data_retention/policies/{policy_id} | Get a granular data retention policy
*MattermostDataRetentionApi* | [**getTeamPoliciesForUser**](doc//MattermostDataRetentionApi.md#getteampoliciesforuser) | **GET** /users/{user_id}/data_retention/team_policies | Get the policies which are applied to a user's teams
*MattermostDataRetentionApi* | [**getTeamsForRetentionPolicy**](doc//MattermostDataRetentionApi.md#getteamsforretentionpolicy) | **GET** /data_retention/policies/{policy_id}/teams | Get the teams for a granular data retention policy
*MattermostDataRetentionApi* | [**patchDataRetentionPolicy**](doc//MattermostDataRetentionApi.md#patchdataretentionpolicy) | **PATCH** /data_retention/policies/{policy_id} | Patch a granular data retention policy
*MattermostDataRetentionApi* | [**removeChannelsFromRetentionPolicy**](doc//MattermostDataRetentionApi.md#removechannelsfromretentionpolicy) | **DELETE** /data_retention/policies/{policy_id}/channels | Delete channels from a granular data retention policy
*MattermostDataRetentionApi* | [**removeTeamsFromRetentionPolicy**](doc//MattermostDataRetentionApi.md#removeteamsfromretentionpolicy) | **DELETE** /data_retention/policies/{policy_id}/teams | Delete teams from a granular data retention policy
*MattermostDataRetentionApi* | [**searchChannelsForRetentionPolicy**](doc//MattermostDataRetentionApi.md#searchchannelsforretentionpolicy) | **POST** /data_retention/policies/{policy_id}/channels/search | Search for the channels in a granular data retention policy
*MattermostDataRetentionApi* | [**searchTeamsForRetentionPolicy**](doc//MattermostDataRetentionApi.md#searchteamsforretentionpolicy) | **POST** /data_retention/policies/{policy_id}/teams/search | Search for the teams in a granular data retention policy
*MattermostElasticsearchApi* | [**purgeElasticsearchIndexes**](doc//MattermostElasticsearchApi.md#purgeelasticsearchindexes) | **POST** /elasticsearch/purge_indexes | Purge all Elasticsearch indexes
*MattermostElasticsearchApi* | [**testElasticsearch**](doc//MattermostElasticsearchApi.md#testelasticsearch) | **POST** /elasticsearch/test | Test Elasticsearch configuration
*MattermostEmojiApi* | [**autocompleteEmoji**](doc//MattermostEmojiApi.md#autocompleteemoji) | **GET** /emoji/autocomplete | Autocomplete custom emoji
*MattermostEmojiApi* | [**createEmoji**](doc//MattermostEmojiApi.md#createemoji) | **POST** /emoji | Create a custom emoji
*MattermostEmojiApi* | [**deleteEmoji**](doc//MattermostEmojiApi.md#deleteemoji) | **DELETE** /emoji/{emoji_id} | Delete a custom emoji
*MattermostEmojiApi* | [**getEmoji**](doc//MattermostEmojiApi.md#getemoji) | **GET** /emoji/{emoji_id} | Get a custom emoji
*MattermostEmojiApi* | [**getEmojiByName**](doc//MattermostEmojiApi.md#getemojibyname) | **GET** /emoji/name/{emoji_name} | Get a custom emoji by name
*MattermostEmojiApi* | [**getEmojiImage**](doc//MattermostEmojiApi.md#getemojiimage) | **GET** /emoji/{emoji_id}/image | Get custom emoji image
*MattermostEmojiApi* | [**getEmojiList**](doc//MattermostEmojiApi.md#getemojilist) | **GET** /emoji | Get a list of custom emoji
*MattermostEmojiApi* | [**searchEmoji**](doc//MattermostEmojiApi.md#searchemoji) | **POST** /emoji/search | Search custom emoji
*MattermostExportsApi* | [**deleteExport**](doc//MattermostExportsApi.md#deleteexport) | **DELETE** /exports/{export_name} | Delete an export file
*MattermostExportsApi* | [**downloadExport**](doc//MattermostExportsApi.md#downloadexport) | **GET** /exports/{export_name} | Download an export file
*MattermostExportsApi* | [**listExports**](doc//MattermostExportsApi.md#listexports) | **GET** /exports | List export files
*MattermostFilesApi* | [**getFile**](doc//MattermostFilesApi.md#getfile) | **GET** /files/{file_id} | Get a file
*MattermostFilesApi* | [**getFileInfo**](doc//MattermostFilesApi.md#getfileinfo) | **GET** /files/{file_id}/info | Get metadata for a file
*MattermostFilesApi* | [**getFileLink**](doc//MattermostFilesApi.md#getfilelink) | **GET** /files/{file_id}/link | Get a public file link
*MattermostFilesApi* | [**getFilePreview**](doc//MattermostFilesApi.md#getfilepreview) | **GET** /files/{file_id}/preview | Get a file's preview
*MattermostFilesApi* | [**getFilePublic**](doc//MattermostFilesApi.md#getfilepublic) | **GET** /files/{file_id}/public | Get a public file
*MattermostFilesApi* | [**getFileThumbnail**](doc//MattermostFilesApi.md#getfilethumbnail) | **GET** /files/{file_id}/thumbnail | Get a file's thumbnail
*MattermostFilesApi* | [**searchFiles**](doc//MattermostFilesApi.md#searchfiles) | **POST** /teams/{team_id}/files/search | Search files in a team
*MattermostFilesApi* | [**uploadFile**](doc//MattermostFilesApi.md#uploadfile) | **POST** /files | Upload a file
*MattermostGroupsApi* | [**addGroupMembers**](doc//MattermostGroupsApi.md#addgroupmembers) | **POST** /groups/{group_id}/members | Adds members to a custom group
*MattermostGroupsApi* | [**createGroup**](doc//MattermostGroupsApi.md#creategroup) | **POST** /groups | Create a custom group
*MattermostGroupsApi* | [**deleteGroup**](doc//MattermostGroupsApi.md#deletegroup) | **DELETE** /groups/{group_id} | Deletes a custom group
*MattermostGroupsApi* | [**deleteGroupMembers**](doc//MattermostGroupsApi.md#deletegroupmembers) | **DELETE** /groups/{group_id}/members | Removes members from a custom group
*MattermostGroupsApi* | [**getGroup**](doc//MattermostGroupsApi.md#getgroup) | **GET** /groups/{group_id} | Get a group
*MattermostGroupsApi* | [**getGroupStats**](doc//MattermostGroupsApi.md#getgroupstats) | **GET** /groups/{group_id}/stats | Get group stats
*MattermostGroupsApi* | [**getGroupSyncableForChannelId**](doc//MattermostGroupsApi.md#getgroupsyncableforchannelid) | **GET** /groups/{group_id}/channels/{channel_id} | Get GroupSyncable from channel ID
*MattermostGroupsApi* | [**getGroupSyncableForTeamId**](doc//MattermostGroupsApi.md#getgroupsyncableforteamid) | **GET** /groups/{group_id}/teams/{team_id} | Get GroupSyncable from Team ID
*MattermostGroupsApi* | [**getGroupSyncablesChannels**](doc//MattermostGroupsApi.md#getgroupsyncableschannels) | **GET** /groups/{group_id}/channels | Get group channels
*MattermostGroupsApi* | [**getGroupSyncablesTeams**](doc//MattermostGroupsApi.md#getgroupsyncablesteams) | **GET** /groups/{group_id}/teams | Get group teams
*MattermostGroupsApi* | [**getGroupUsers**](doc//MattermostGroupsApi.md#getgroupusers) | **GET** /groups/{group_id}/members | Get group users
*MattermostGroupsApi* | [**getGroups**](doc//MattermostGroupsApi.md#getgroups) | **GET** /groups | Get groups
*MattermostGroupsApi* | [**getGroupsAssociatedToChannelsByTeam**](doc//MattermostGroupsApi.md#getgroupsassociatedtochannelsbyteam) | **GET** /teams/{team_id}/groups_by_channels | Get team groups by channels
*MattermostGroupsApi* | [**getGroupsByChannel**](doc//MattermostGroupsApi.md#getgroupsbychannel) | **GET** /channels/{channel_id}/groups | Get channel groups
*MattermostGroupsApi* | [**getGroupsByTeam**](doc//MattermostGroupsApi.md#getgroupsbyteam) | **GET** /teams/{team_id}/groups | Get team groups
*MattermostGroupsApi* | [**getGroupsByUserId**](doc//MattermostGroupsApi.md#getgroupsbyuserid) | **GET** /users/{user_id}/groups | Get groups for a userId
*MattermostGroupsApi* | [**linkGroupSyncableForChannel**](doc//MattermostGroupsApi.md#linkgroupsyncableforchannel) | **POST** /groups/{group_id}/channels/{channel_id}/link | Link a channel to a group
*MattermostGroupsApi* | [**linkGroupSyncableForTeam**](doc//MattermostGroupsApi.md#linkgroupsyncableforteam) | **POST** /groups/{group_id}/teams/{team_id}/link | Link a team to a group
*MattermostGroupsApi* | [**patchGroup**](doc//MattermostGroupsApi.md#patchgroup) | **PUT** /groups/{group_id}/patch | Patch a group
*MattermostGroupsApi* | [**patchGroupSyncableForChannel**](doc//MattermostGroupsApi.md#patchgroupsyncableforchannel) | **PUT** /groups/{group_id}/channels/{channel_id}/patch | Patch a GroupSyncable associated to Channel
*MattermostGroupsApi* | [**patchGroupSyncableForTeam**](doc//MattermostGroupsApi.md#patchgroupsyncableforteam) | **PUT** /groups/{group_id}/teams/{team_id}/patch | Patch a GroupSyncable associated to Team
*MattermostGroupsApi* | [**unlinkGroupSyncableForChannel**](doc//MattermostGroupsApi.md#unlinkgroupsyncableforchannel) | **DELETE** /groups/{group_id}/channels/{channel_id}/link | Delete a link from a channel to a group
*MattermostGroupsApi* | [**unlinkGroupSyncableForTeam**](doc//MattermostGroupsApi.md#unlinkgroupsyncableforteam) | **DELETE** /groups/{group_id}/teams/{team_id}/link | Delete a link from a team to a group
*MattermostGroupsApi* | [**unlinkLdapGroup**](doc//MattermostGroupsApi.md#unlinkldapgroup) | **DELETE** /ldap/groups/{remote_id}/link | Delete a link for LDAP group
*MattermostImportsApi* | [**listImports**](doc//MattermostImportsApi.md#listimports) | **GET** /imports | List import files
*MattermostInsightsApi* | [**getTopChannelsForTeam**](doc//MattermostInsightsApi.md#gettopchannelsforteam) | **GET** /teams/{team_id}/top/channels | Get a list of the top channels for a team.
*MattermostInsightsApi* | [**getTopChannelsForUser**](doc//MattermostInsightsApi.md#gettopchannelsforuser) | **GET** /users/me/top/channels | Get a list of the top channels for a user.
*MattermostInsightsApi* | [**getTopReactionsForTeam**](doc//MattermostInsightsApi.md#gettopreactionsforteam) | **GET** /teams/{team_id}/top/reactions | Get a list of the top reactions for a team.
*MattermostInsightsApi* | [**getTopReactionsForUser**](doc//MattermostInsightsApi.md#gettopreactionsforuser) | **GET** /users/me/top/reactions | Get a list of the top reactions for a user.
*MattermostIntegrationActionsApi* | [**openInteractiveDialog**](doc//MattermostIntegrationActionsApi.md#openinteractivedialog) | **POST** /actions/dialogs/open | Open a dialog
*MattermostIntegrationActionsApi* | [**submitInteractiveDialog**](doc//MattermostIntegrationActionsApi.md#submitinteractivedialog) | **POST** /actions/dialogs/submit | Submit a dialog
*MattermostJobsApi* | [**cancelJob**](doc//MattermostJobsApi.md#canceljob) | **POST** /jobs/{job_id}/cancel | Cancel a job.
*MattermostJobsApi* | [**createJob**](doc//MattermostJobsApi.md#createjob) | **POST** /jobs | Create a new job.
*MattermostJobsApi* | [**downloadJob**](doc//MattermostJobsApi.md#downloadjob) | **GET** /jobs/{job_id}/download | Download the results of a job.
*MattermostJobsApi* | [**getJob**](doc//MattermostJobsApi.md#getjob) | **GET** /jobs/{job_id} | Get a job.
*MattermostJobsApi* | [**getJobs**](doc//MattermostJobsApi.md#getjobs) | **GET** /jobs | Get the jobs.
*MattermostJobsApi* | [**getJobsByType**](doc//MattermostJobsApi.md#getjobsbytype) | **GET** /jobs/type/{type} | Get the jobs of the given type.
*MattermostLDAPApi* | [**deleteLdapPrivateCertificate**](doc//MattermostLDAPApi.md#deleteldapprivatecertificate) | **DELETE** /ldap/certificate/private | Remove private key
*MattermostLDAPApi* | [**deleteLdapPublicCertificate**](doc//MattermostLDAPApi.md#deleteldappubliccertificate) | **DELETE** /ldap/certificate/public | Remove public certificate
*MattermostLDAPApi* | [**getLdapGroups**](doc//MattermostLDAPApi.md#getldapgroups) | **GET** /ldap/groups | Returns a list of LDAP groups
*MattermostLDAPApi* | [**linkLdapGroup**](doc//MattermostLDAPApi.md#linkldapgroup) | **POST** /ldap/groups/{remote_id}/link | Link a LDAP group
*MattermostLDAPApi* | [**migrateAuthToLdap**](doc//MattermostLDAPApi.md#migrateauthtoldap) | **POST** /users/migrate_auth/ldap | Migrate user accounts authentication type to LDAP.
*MattermostLDAPApi* | [**migrateIdLdap**](doc//MattermostLDAPApi.md#migrateidldap) | **POST** /ldap/migrateid | Migrate Id LDAP
*MattermostLDAPApi* | [**syncLdap**](doc//MattermostLDAPApi.md#syncldap) | **POST** /ldap/sync | Sync with LDAP
*MattermostLDAPApi* | [**testLdap**](doc//MattermostLDAPApi.md#testldap) | **POST** /ldap/test | Test LDAP configuration
*MattermostLDAPApi* | [**uploadLdapPrivateCertificate**](doc//MattermostLDAPApi.md#uploadldapprivatecertificate) | **POST** /ldap/certificate/private | Upload private key
*MattermostLDAPApi* | [**uploadLdapPublicCertificate**](doc//MattermostLDAPApi.md#uploadldappubliccertificate) | **POST** /ldap/certificate/public | Upload public certificate
*MattermostMigrateApi* | [**migrateAuthToLdap**](doc//MattermostMigrateApi.md#migrateauthtoldap) | **POST** /users/migrate_auth/ldap | Migrate user accounts authentication type to LDAP.
*MattermostMigrateApi* | [**migrateAuthToSaml**](doc//MattermostMigrateApi.md#migrateauthtosaml) | **POST** /users/migrate_auth/saml | Migrate user accounts authentication type to SAML.
*MattermostOAuthApi* | [**createOAuthApp**](doc//MattermostOAuthApi.md#createoauthapp) | **POST** /oauth/apps | Register OAuth app
*MattermostOAuthApi* | [**deleteOAuthApp**](doc//MattermostOAuthApi.md#deleteoauthapp) | **DELETE** /oauth/apps/{app_id} | Delete an OAuth app
*MattermostOAuthApi* | [**getAuthorizedOAuthAppsForUser**](doc//MattermostOAuthApi.md#getauthorizedoauthappsforuser) | **GET** /users/{user_id}/oauth/apps/authorized | Get authorized OAuth apps
*MattermostOAuthApi* | [**getOAuthApp**](doc//MattermostOAuthApi.md#getoauthapp) | **GET** /oauth/apps/{app_id} | Get an OAuth app
*MattermostOAuthApi* | [**getOAuthAppInfo**](doc//MattermostOAuthApi.md#getoauthappinfo) | **GET** /oauth/apps/{app_id}/info | Get info on an OAuth app
*MattermostOAuthApi* | [**getOAuthApps**](doc//MattermostOAuthApi.md#getoauthapps) | **GET** /oauth/apps | Get OAuth apps
*MattermostOAuthApi* | [**regenerateOAuthAppSecret**](doc//MattermostOAuthApi.md#regenerateoauthappsecret) | **POST** /oauth/apps/{app_id}/regen_secret | Regenerate OAuth app secret
*MattermostOAuthApi* | [**updateOAuthApp**](doc//MattermostOAuthApi.md#updateoauthapp) | **PUT** /oauth/apps/{app_id} | Update an OAuth app
*MattermostOpenGraphApi* | [**openGraph**](doc//MattermostOpenGraphApi.md#opengraph) | **POST** /opengraph | Get open graph metadata for url
*MattermostPermissionsApi* | [**getAncillaryPermissions**](doc//MattermostPermissionsApi.md#getancillarypermissions) | **GET** /permissions/ancillary | Return all system console subsection ancillary permissions
*MattermostPluginsApi* | [**disablePlugin**](doc//MattermostPluginsApi.md#disableplugin) | **POST** /plugins/{plugin_id}/disable | Disable plugin
*MattermostPluginsApi* | [**enablePlugin**](doc//MattermostPluginsApi.md#enableplugin) | **POST** /plugins/{plugin_id}/enable | Enable plugin
*MattermostPluginsApi* | [**getMarketplacePlugins**](doc//MattermostPluginsApi.md#getmarketplaceplugins) | **GET** /plugins/marketplace | Gets all the marketplace plugins
*MattermostPluginsApi* | [**getMarketplaceVisitedByAdmin**](doc//MattermostPluginsApi.md#getmarketplacevisitedbyadmin) | **GET** /plugins/marketplace/first_admin_visit | Get if the Plugin Marketplace has been visited by at least an admin.
*MattermostPluginsApi* | [**getPluginStatuses**](doc//MattermostPluginsApi.md#getpluginstatuses) | **GET** /plugins/statuses | Get plugins status
*MattermostPluginsApi* | [**getPlugins**](doc//MattermostPluginsApi.md#getplugins) | **GET** /plugins | Get plugins
*MattermostPluginsApi* | [**getWebappPlugins**](doc//MattermostPluginsApi.md#getwebappplugins) | **GET** /plugins/webapp | Get webapp plugins
*MattermostPluginsApi* | [**installMarketplacePlugin**](doc//MattermostPluginsApi.md#installmarketplaceplugin) | **POST** /plugins/marketplace | Installs a marketplace plugin
*MattermostPluginsApi* | [**installPluginFromUrl**](doc//MattermostPluginsApi.md#installpluginfromurl) | **POST** /plugins/install_from_url | Install plugin from url
*MattermostPluginsApi* | [**removePlugin**](doc//MattermostPluginsApi.md#removeplugin) | **DELETE** /plugins/{plugin_id} | Remove plugin
*MattermostPluginsApi* | [**uploadPlugin**](doc//MattermostPluginsApi.md#uploadplugin) | **POST** /plugins | Upload plugin
*MattermostPostsApi* | [**createPost**](doc//MattermostPostsApi.md#createpost) | **POST** /posts | Create a post
*MattermostPostsApi* | [**createPostEphemeral**](doc//MattermostPostsApi.md#createpostephemeral) | **POST** /posts/ephemeral | Create a ephemeral post
*MattermostPostsApi* | [**deletePost**](doc//MattermostPostsApi.md#deletepost) | **DELETE** /posts/{post_id} | Delete a post
*MattermostPostsApi* | [**doPostAction**](doc//MattermostPostsApi.md#dopostaction) | **POST** /posts/{post_id}/actions/{action_id} | Perform a post action
*MattermostPostsApi* | [**getFileInfosForPost**](doc//MattermostPostsApi.md#getfileinfosforpost) | **GET** /posts/{post_id}/files/info | Get file info for post
*MattermostPostsApi* | [**getFlaggedPostsForUser**](doc//MattermostPostsApi.md#getflaggedpostsforuser) | **GET** /users/{user_id}/posts/flagged | Get a list of flagged posts
*MattermostPostsApi* | [**getPost**](doc//MattermostPostsApi.md#getpost) | **GET** /posts/{post_id} | Get a post
*MattermostPostsApi* | [**getPostThread**](doc//MattermostPostsApi.md#getpostthread) | **GET** /posts/{post_id}/thread | Get a thread
*MattermostPostsApi* | [**getPostsAroundLastUnread**](doc//MattermostPostsApi.md#getpostsaroundlastunread) | **GET** /users/{user_id}/channels/{channel_id}/posts/unread | Get posts around oldest unread
*MattermostPostsApi* | [**getPostsByIds**](doc//MattermostPostsApi.md#getpostsbyids) | **POST** /posts/ids | Get posts by a list of ids
*MattermostPostsApi* | [**getPostsForChannel**](doc//MattermostPostsApi.md#getpostsforchannel) | **GET** /channels/{channel_id}/posts | Get posts for a channel
*MattermostPostsApi* | [**patchPost**](doc//MattermostPostsApi.md#patchpost) | **PUT** /posts/{post_id}/patch | Patch a post
*MattermostPostsApi* | [**pinPost**](doc//MattermostPostsApi.md#pinpost) | **POST** /posts/{post_id}/pin | Pin a post to the channel
*MattermostPostsApi* | [**searchPosts**](doc//MattermostPostsApi.md#searchposts) | **POST** /teams/{team_id}/posts/search | Search for team posts
*MattermostPostsApi* | [**setPostUnread**](doc//MattermostPostsApi.md#setpostunread) | **POST** /users/{user_id}/posts/{post_id}/set_unread | Mark as unread from a post.
*MattermostPostsApi* | [**unpinPost**](doc//MattermostPostsApi.md#unpinpost) | **POST** /posts/{post_id}/unpin | Unpin a post to the channel
*MattermostPostsApi* | [**updatePost**](doc//MattermostPostsApi.md#updatepost) | **PUT** /posts/{post_id} | Update a post
*MattermostPreferencesApi* | [**deletePreferences**](doc//MattermostPreferencesApi.md#deletepreferences) | **POST** /users/{user_id}/preferences/delete | Delete user's preferences
*MattermostPreferencesApi* | [**getPreferences**](doc//MattermostPreferencesApi.md#getpreferences) | **GET** /users/{user_id}/preferences | Get the user's preferences
*MattermostPreferencesApi* | [**getPreferencesByCategory**](doc//MattermostPreferencesApi.md#getpreferencesbycategory) | **GET** /users/{user_id}/preferences/{category} | List a user's preferences by category
*MattermostPreferencesApi* | [**getPreferencesByCategoryByName**](doc//MattermostPreferencesApi.md#getpreferencesbycategorybyname) | **GET** /users/{user_id}/preferences/{category}/name/{preference_name} | Get a specific user preference
*MattermostPreferencesApi* | [**updatePreferences**](doc//MattermostPreferencesApi.md#updatepreferences) | **PUT** /users/{user_id}/preferences | Save the user's preferences
*MattermostReactionsApi* | [**deleteReaction**](doc//MattermostReactionsApi.md#deletereaction) | **DELETE** /users/{user_id}/posts/{post_id}/reactions/{emoji_name} | Remove a reaction from a post
*MattermostReactionsApi* | [**getBulkReactions**](doc//MattermostReactionsApi.md#getbulkreactions) | **POST** /posts/ids/reactions | Bulk get the reaction for posts
*MattermostReactionsApi* | [**getReactions**](doc//MattermostReactionsApi.md#getreactions) | **GET** /posts/{post_id}/reactions | Get a list of reactions to a post
*MattermostReactionsApi* | [**saveReaction**](doc//MattermostReactionsApi.md#savereaction) | **POST** /reactions | Create a reaction
*MattermostRolesApi* | [**getAllRoles**](doc//MattermostRolesApi.md#getallroles) | **GET** /roles | Get a list of all the roles
*MattermostRolesApi* | [**getRole**](doc//MattermostRolesApi.md#getrole) | **GET** /roles/{role_id} | Get a role
*MattermostRolesApi* | [**getRoleByName**](doc//MattermostRolesApi.md#getrolebyname) | **GET** /roles/name/{role_name} | Get a role
*MattermostRolesApi* | [**getRolesByNames**](doc//MattermostRolesApi.md#getrolesbynames) | **POST** /roles/names | Get a list of roles by name
*MattermostRolesApi* | [**patchRole**](doc//MattermostRolesApi.md#patchrole) | **PUT** /roles/{role_id}/patch | Patch a role
*MattermostRootApi* | [**acknowledgeNotification**](doc//MattermostRootApi.md#acknowledgenotification) | **POST** /notifications/ack | Acknowledge receiving of a notification
*MattermostSAMLApi* | [**deleteSamlIdpCertificate**](doc//MattermostSAMLApi.md#deletesamlidpcertificate) | **DELETE** /saml/certificate/idp | Remove IDP certificate
*MattermostSAMLApi* | [**deleteSamlPrivateCertificate**](doc//MattermostSAMLApi.md#deletesamlprivatecertificate) | **DELETE** /saml/certificate/private | Remove private key
*MattermostSAMLApi* | [**deleteSamlPublicCertificate**](doc//MattermostSAMLApi.md#deletesamlpubliccertificate) | **DELETE** /saml/certificate/public | Remove public certificate
*MattermostSAMLApi* | [**getSamlCertificateStatus**](doc//MattermostSAMLApi.md#getsamlcertificatestatus) | **GET** /saml/certificate/status | Get certificate status
*MattermostSAMLApi* | [**getSamlMetadata**](doc//MattermostSAMLApi.md#getsamlmetadata) | **GET** /saml/metadata | Get metadata
*MattermostSAMLApi* | [**getSamlMetadataFromIdp**](doc//MattermostSAMLApi.md#getsamlmetadatafromidp) | **POST** /saml/metadatafromidp | Get metadata from Identity Provider
*MattermostSAMLApi* | [**migrateAuthToSaml**](doc//MattermostSAMLApi.md#migrateauthtosaml) | **POST** /users/migrate_auth/saml | Migrate user accounts authentication type to SAML.
*MattermostSAMLApi* | [**resetSamlAuthDataToEmail**](doc//MattermostSAMLApi.md#resetsamlauthdatatoemail) | **POST** /saml/reset_auth_data | Reset AuthData to Email
*MattermostSAMLApi* | [**uploadSamlIdpCertificate**](doc//MattermostSAMLApi.md#uploadsamlidpcertificate) | **POST** /saml/certificate/idp | Upload IDP certificate
*MattermostSAMLApi* | [**uploadSamlPrivateCertificate**](doc//MattermostSAMLApi.md#uploadsamlprivatecertificate) | **POST** /saml/certificate/private | Upload private key
*MattermostSAMLApi* | [**uploadSamlPublicCertificate**](doc//MattermostSAMLApi.md#uploadsamlpubliccertificate) | **POST** /saml/certificate/public | Upload public certificate
*MattermostSchemesApi* | [**createScheme**](doc//MattermostSchemesApi.md#createscheme) | **POST** /schemes | Create a scheme
*MattermostSchemesApi* | [**deleteScheme**](doc//MattermostSchemesApi.md#deletescheme) | **DELETE** /schemes/{scheme_id} | Delete a scheme
*MattermostSchemesApi* | [**getChannelsForScheme**](doc//MattermostSchemesApi.md#getchannelsforscheme) | **GET** /schemes/{scheme_id}/channels | Get a page of channels which use this scheme.
*MattermostSchemesApi* | [**getScheme**](doc//MattermostSchemesApi.md#getscheme) | **GET** /schemes/{scheme_id} | Get a scheme
*MattermostSchemesApi* | [**getSchemes**](doc//MattermostSchemesApi.md#getschemes) | **GET** /schemes | Get the schemes.
*MattermostSchemesApi* | [**getTeamsForScheme**](doc//MattermostSchemesApi.md#getteamsforscheme) | **GET** /schemes/{scheme_id}/teams | Get a page of teams which use this scheme.
*MattermostSchemesApi* | [**patchScheme**](doc//MattermostSchemesApi.md#patchscheme) | **PUT** /schemes/{scheme_id}/patch | Patch a scheme
*MattermostSearchApi* | [**searchFiles**](doc//MattermostSearchApi.md#searchfiles) | **POST** /teams/{team_id}/files/search | Search files in a team
*MattermostSharedChannelsApi* | [**getAllSharedChannels**](doc//MattermostSharedChannelsApi.md#getallsharedchannels) | **GET** /sharedchannels/{team_id} | Get all shared channels for team.
*MattermostSharedChannelsApi* | [**getRemoteClusterInfo**](doc//MattermostSharedChannelsApi.md#getremoteclusterinfo) | **GET** /sharedchannels/remote_info/{remote_id} | Get remote cluster info by ID for user.
*MattermostStatusApi* | [**getUserStatus**](doc//MattermostStatusApi.md#getuserstatus) | **GET** /users/{user_id}/status | Get user status
*MattermostStatusApi* | [**getUsersStatusesByIds**](doc//MattermostStatusApi.md#getusersstatusesbyids) | **POST** /users/status/ids | Get user statuses by id
*MattermostStatusApi* | [**postUserRecentCustomStatusDelete**](doc//MattermostStatusApi.md#postuserrecentcustomstatusdelete) | **POST** /users/{user_id}/status/custom/recent/delete | Delete user's recent custom status
*MattermostStatusApi* | [**removeRecentCustomStatus**](doc//MattermostStatusApi.md#removerecentcustomstatus) | **DELETE** /users/{user_id}/status/custom/recent | Delete user's recent custom status
*MattermostStatusApi* | [**unsetUserCustomStatus**](doc//MattermostStatusApi.md#unsetusercustomstatus) | **DELETE** /users/{user_id}/status/custom | Unsets user custom status
*MattermostStatusApi* | [**updateUserCustomStatus**](doc//MattermostStatusApi.md#updateusercustomstatus) | **PUT** /users/{user_id}/status/custom | Update user custom status
*MattermostStatusApi* | [**updateUserStatus**](doc//MattermostStatusApi.md#updateuserstatus) | **PUT** /users/{user_id}/status | Update user status
*MattermostSystemApi* | [**checkIntegrity**](doc//MattermostSystemApi.md#checkintegrity) | **POST** /integrity | Perform a database integrity check
*MattermostSystemApi* | [**clearServerBusy**](doc//MattermostSystemApi.md#clearserverbusy) | **DELETE** /server_busy | Clears the server busy (high load) flag
*MattermostSystemApi* | [**databaseRecycle**](doc//MattermostSystemApi.md#databaserecycle) | **POST** /database/recycle | Recycle database connections
*MattermostSystemApi* | [**generateSupportPacket**](doc//MattermostSystemApi.md#generatesupportpacket) | **GET** /system/support_packet | Download a zip file which contains helpful and useful information for troubleshooting your mattermost instance.
*MattermostSystemApi* | [**getAnalyticsOld**](doc//MattermostSystemApi.md#getanalyticsold) | **GET** /analytics/old | Get analytics
*MattermostSystemApi* | [**getAudits**](doc//MattermostSystemApi.md#getaudits) | **GET** /audits | Get audits
*MattermostSystemApi* | [**getClientConfig**](doc//MattermostSystemApi.md#getclientconfig) | **GET** /config/client | Get client configuration
*MattermostSystemApi* | [**getClientLicense**](doc//MattermostSystemApi.md#getclientlicense) | **GET** /license/client | Get client license
*MattermostSystemApi* | [**getConfig**](doc//MattermostSystemApi.md#getconfig) | **GET** /config | Get configuration
*MattermostSystemApi* | [**getEnvironmentConfig**](doc//MattermostSystemApi.md#getenvironmentconfig) | **GET** /config/environment | Get configuration made through environment variables
*MattermostSystemApi* | [**getImageByUrl**](doc//MattermostSystemApi.md#getimagebyurl) | **GET** /image | Get an image by url
*MattermostSystemApi* | [**getLogs**](doc//MattermostSystemApi.md#getlogs) | **GET** /logs | Get logs
*MattermostSystemApi* | [**getNotices**](doc//MattermostSystemApi.md#getnotices) | **GET** /system/notices/{teamId} | Get notices for logged in user in specified team
*MattermostSystemApi* | [**getPing**](doc//MattermostSystemApi.md#getping) | **GET** /system/ping | Check system health
*MattermostSystemApi* | [**getRedirectLocation**](doc//MattermostSystemApi.md#getredirectlocation) | **GET** /redirect_location | Get redirect location
*MattermostSystemApi* | [**getServerBusyExpires**](doc//MattermostSystemApi.md#getserverbusyexpires) | **GET** /server_busy | Get server busy expiry time.
*MattermostSystemApi* | [**getSupportedTimezone**](doc//MattermostSystemApi.md#getsupportedtimezone) | **GET** /system/timezones | Retrieve a list of supported timezones
*MattermostSystemApi* | [**getWarnMetricsStatus**](doc//MattermostSystemApi.md#getwarnmetricsstatus) | **GET** /warn_metrics/status | Get the warn metrics status (enabled or disabled)
*MattermostSystemApi* | [**invalidateCaches**](doc//MattermostSystemApi.md#invalidatecaches) | **POST** /caches/invalidate | Invalidate all the caches
*MattermostSystemApi* | [**markNoticesViewed**](doc//MattermostSystemApi.md#marknoticesviewed) | **PUT** /system/notices/view | Update notices as 'viewed'
*MattermostSystemApi* | [**patchConfig**](doc//MattermostSystemApi.md#patchconfig) | **PUT** /config/patch | Patch configuration
*MattermostSystemApi* | [**postLog**](doc//MattermostSystemApi.md#postlog) | **POST** /logs | Add log message
*MattermostSystemApi* | [**reloadConfig**](doc//MattermostSystemApi.md#reloadconfig) | **POST** /config/reload | Reload configuration
*MattermostSystemApi* | [**removeLicenseFile**](doc//MattermostSystemApi.md#removelicensefile) | **DELETE** /license | Remove license file
*MattermostSystemApi* | [**requestLicenseRenewalLink**](doc//MattermostSystemApi.md#requestlicenserenewallink) | **GET** /license/renewal | Request the license renewal link
*MattermostSystemApi* | [**requestTrialLicense**](doc//MattermostSystemApi.md#requesttriallicense) | **POST** /trial-license | Request and install a trial license for your server
*MattermostSystemApi* | [**restartServer**](doc//MattermostSystemApi.md#restartserver) | **POST** /restart | Restart the system after an upgrade from Team Edition to Enterprise Edition
*MattermostSystemApi* | [**sendTrialLicenseWarnMetricAck**](doc//MattermostSystemApi.md#sendtriallicensewarnmetricack) | **POST** /warn_metrics/trial-license-ack/{warn_metric_id} | Request trial license and acknowledge a warning of a metric status
*MattermostSystemApi* | [**sendWarnMetricAck**](doc//MattermostSystemApi.md#sendwarnmetricack) | **POST** /warn_metrics/ack/{warn_metric_id} | Acknowledge a warning of a metric status
*MattermostSystemApi* | [**setServerBusy**](doc//MattermostSystemApi.md#setserverbusy) | **POST** /server_busy | Set the server busy (high load) flag
*MattermostSystemApi* | [**testEmail**](doc//MattermostSystemApi.md#testemail) | **POST** /email/test | Send a test email
*MattermostSystemApi* | [**testS3Connection**](doc//MattermostSystemApi.md#tests3connection) | **POST** /file/s3_test | Test AWS S3 connection
*MattermostSystemApi* | [**testSiteURL**](doc//MattermostSystemApi.md#testsiteurl) | **POST** /site_url/test | Checks the validity of a Site URL
*MattermostSystemApi* | [**trialLicensePrevGet**](doc//MattermostSystemApi.md#triallicenseprevget) | **GET** /trial-license/prev | Get last trial license used
*MattermostSystemApi* | [**updateConfig**](doc//MattermostSystemApi.md#updateconfig) | **PUT** /config | Update configuration
*MattermostSystemApi* | [**updateMarketplaceVisitedByAdmin**](doc//MattermostSystemApi.md#updatemarketplacevisitedbyadmin) | **POST** /plugins/marketplace/first_admin_visit | Stores that the Plugin Marketplace has been visited by at least an admin.
*MattermostSystemApi* | [**upgradeToEnterprise**](doc//MattermostSystemApi.md#upgradetoenterprise) | **POST** /upgrade_to_enterprise | Executes an inplace upgrade from Team Edition to Enterprise Edition
*MattermostSystemApi* | [**upgradeToEnterpriseStatus**](doc//MattermostSystemApi.md#upgradetoenterprisestatus) | **GET** /upgrade_to_enterprise/status | Get the current status for the inplace upgrade from Team Edition to Enterprise Edition
*MattermostSystemApi* | [**uploadLicenseFile**](doc//MattermostSystemApi.md#uploadlicensefile) | **POST** /license | Upload license file
*MattermostTeamsApi* | [**addTeamMember**](doc//MattermostTeamsApi.md#addteammember) | **POST** /teams/{team_id}/members | Add user to team
*MattermostTeamsApi* | [**addTeamMemberFromInvite**](doc//MattermostTeamsApi.md#addteammemberfrominvite) | **POST** /teams/members/invite | Add user to team from invite
*MattermostTeamsApi* | [**addTeamMembers**](doc//MattermostTeamsApi.md#addteammembers) | **POST** /teams/{team_id}/members/batch | Add multiple users to team
*MattermostTeamsApi* | [**createTeam**](doc//MattermostTeamsApi.md#createteam) | **POST** /teams | Create a team
*MattermostTeamsApi* | [**getAllTeams**](doc//MattermostTeamsApi.md#getallteams) | **GET** /teams | Get teams
*MattermostTeamsApi* | [**getTeam**](doc//MattermostTeamsApi.md#getteam) | **GET** /teams/{team_id} | Get a team
*MattermostTeamsApi* | [**getTeamByName**](doc//MattermostTeamsApi.md#getteambyname) | **GET** /teams/name/{name} | Get a team by name
*MattermostTeamsApi* | [**getTeamIcon**](doc//MattermostTeamsApi.md#getteamicon) | **GET** /teams/{team_id}/image | Get the team icon
*MattermostTeamsApi* | [**getTeamInviteInfo**](doc//MattermostTeamsApi.md#getteaminviteinfo) | **GET** /teams/invite/{invite_id} | Get invite info for a team
*MattermostTeamsApi* | [**getTeamMember**](doc//MattermostTeamsApi.md#getteammember) | **GET** /teams/{team_id}/members/{user_id} | Get a team member
*MattermostTeamsApi* | [**getTeamMembers**](doc//MattermostTeamsApi.md#getteammembers) | **GET** /teams/{team_id}/members | Get team members
*MattermostTeamsApi* | [**getTeamMembersByIds**](doc//MattermostTeamsApi.md#getteammembersbyids) | **POST** /teams/{team_id}/members/ids | Get team members by ids
*MattermostTeamsApi* | [**getTeamMembersForUser**](doc//MattermostTeamsApi.md#getteammembersforuser) | **GET** /users/{user_id}/teams/members | Get team members for a user
*MattermostTeamsApi* | [**getTeamStats**](doc//MattermostTeamsApi.md#getteamstats) | **GET** /teams/{team_id}/stats | Get a team stats
*MattermostTeamsApi* | [**getTeamUnread**](doc//MattermostTeamsApi.md#getteamunread) | **GET** /users/{user_id}/teams/{team_id}/unread | Get unreads for a team
*MattermostTeamsApi* | [**getTeamsForUser**](doc//MattermostTeamsApi.md#getteamsforuser) | **GET** /users/{user_id}/teams | Get a user's teams
*MattermostTeamsApi* | [**getTeamsUnreadForUser**](doc//MattermostTeamsApi.md#getteamsunreadforuser) | **GET** /users/{user_id}/teams/unread | Get team unreads for a user
*MattermostTeamsApi* | [**importTeam**](doc//MattermostTeamsApi.md#importteam) | **POST** /teams/{team_id}/import | Import a Team from other application
*MattermostTeamsApi* | [**invalidateEmailInvites**](doc//MattermostTeamsApi.md#invalidateemailinvites) | **DELETE** /teams/invites/email | Invalidate active email invitations
*MattermostTeamsApi* | [**inviteGuestsToTeam**](doc//MattermostTeamsApi.md#invitegueststoteam) | **POST** /teams/{team_id}/invite-guests/email | Invite guests to the team by email
*MattermostTeamsApi* | [**inviteUsersToTeam**](doc//MattermostTeamsApi.md#inviteuserstoteam) | **POST** /teams/{team_id}/invite/email | Invite users to the team by email
*MattermostTeamsApi* | [**patchTeam**](doc//MattermostTeamsApi.md#patchteam) | **PUT** /teams/{team_id}/patch | Patch a team
*MattermostTeamsApi* | [**regenerateTeamInviteId**](doc//MattermostTeamsApi.md#regenerateteaminviteid) | **POST** /teams/{team_id}/regenerate_invite_id | Regenerate the Invite ID from a Team
*MattermostTeamsApi* | [**removeTeamIcon**](doc//MattermostTeamsApi.md#removeteamicon) | **DELETE** /teams/{team_id}/image | Remove the team icon
*MattermostTeamsApi* | [**removeTeamMember**](doc//MattermostTeamsApi.md#removeteammember) | **DELETE** /teams/{team_id}/members/{user_id} | Remove user from team
*MattermostTeamsApi* | [**restoreTeam**](doc//MattermostTeamsApi.md#restoreteam) | **POST** /teams/{team_id}/restore | Restore a team
*MattermostTeamsApi* | [**searchFiles**](doc//MattermostTeamsApi.md#searchfiles) | **POST** /teams/{team_id}/files/search | Search files in a team
*MattermostTeamsApi* | [**searchTeams**](doc//MattermostTeamsApi.md#searchteams) | **POST** /teams/search | Search teams
*MattermostTeamsApi* | [**setTeamIcon**](doc//MattermostTeamsApi.md#setteamicon) | **POST** /teams/{team_id}/image | Sets the team icon
*MattermostTeamsApi* | [**softDeleteTeam**](doc//MattermostTeamsApi.md#softdeleteteam) | **DELETE** /teams/{team_id} | Delete a team
*MattermostTeamsApi* | [**teamExists**](doc//MattermostTeamsApi.md#teamexists) | **GET** /teams/name/{name}/exists | Check if team exists
*MattermostTeamsApi* | [**teamMembersMinusGroupMembers**](doc//MattermostTeamsApi.md#teammembersminusgroupmembers) | **GET** /teams/{team_id}/members_minus_group_members | Team members minus group members.
*MattermostTeamsApi* | [**updateTeam**](doc//MattermostTeamsApi.md#updateteam) | **PUT** /teams/{team_id} | Update a team
*MattermostTeamsApi* | [**updateTeamMemberRoles**](doc//MattermostTeamsApi.md#updateteammemberroles) | **PUT** /teams/{team_id}/members/{user_id}/roles | Update a team member roles
*MattermostTeamsApi* | [**updateTeamMemberSchemeRoles**](doc//MattermostTeamsApi.md#updateteammemberschemeroles) | **PUT** /teams/{team_id}/members/{user_id}/schemeRoles | Update the scheme-derived roles of a team member.
*MattermostTeamsApi* | [**updateTeamPrivacy**](doc//MattermostTeamsApi.md#updateteamprivacy) | **PUT** /teams/{team_id}/privacy | Update teams's privacy
*MattermostTeamsApi* | [**updateTeamScheme**](doc//MattermostTeamsApi.md#updateteamscheme) | **PUT** /teams/{team_id}/scheme | Set a team's scheme
*MattermostTermsOfServiceApi* | [**createTermsOfService**](doc//MattermostTermsOfServiceApi.md#createtermsofservice) | **POST** /terms_of_service | Creates a new terms of service
*MattermostTermsOfServiceApi* | [**getTermsOfService**](doc//MattermostTermsOfServiceApi.md#gettermsofservice) | **GET** /terms_of_service | Get latest terms of service
*MattermostTermsOfServiceApi* | [**getUserTermsOfService**](doc//MattermostTermsOfServiceApi.md#getusertermsofservice) | **GET** /users/{user_id}/terms_of_service | Fetches user's latest terms of service action if the latest action was for acceptance.
*MattermostTermsOfServiceApi* | [**registerTermsOfServiceAction**](doc//MattermostTermsOfServiceApi.md#registertermsofserviceaction) | **POST** /users/{user_id}/terms_of_service | Records user action when they accept or decline custom terms of service
*MattermostThreadsApi* | [**getThreadMentionCountsByChannel**](doc//MattermostThreadsApi.md#getthreadmentioncountsbychannel) | **GET** /users/{user_id}/teams/{team_id}/threads/mention_counts | Get all unread mention counts from followed threads, per-channel
*MattermostThreadsApi* | [**getUserThread**](doc//MattermostThreadsApi.md#getuserthread) | **GET** /users/{user_id}/teams/{team_id}/threads/{thread_id} | Get a thread followed by the user
*MattermostThreadsApi* | [**getUserThreads**](doc//MattermostThreadsApi.md#getuserthreads) | **GET** /users/{user_id}/teams/{team_id}/threads | Get all threads that user is following
*MattermostThreadsApi* | [**startFollowingThread**](doc//MattermostThreadsApi.md#startfollowingthread) | **PUT** /users/{user_id}/teams/{team_id}/threads/{thread_id}/following | Start following a thread
*MattermostThreadsApi* | [**stopFollowingThread**](doc//MattermostThreadsApi.md#stopfollowingthread) | **DELETE** /users/{user_id}/teams/{team_id}/threads/{thread_id}/following | Stop following a thread
*MattermostThreadsApi* | [**updateThreadReadForUser**](doc//MattermostThreadsApi.md#updatethreadreadforuser) | **PUT** /users/{user_id}/teams/{team_id}/threads/{thread_id}/read/{timestamp} | Mark a thread that user is following read state to the timestamp
*MattermostThreadsApi* | [**updateThreadsReadForUser**](doc//MattermostThreadsApi.md#updatethreadsreadforuser) | **PUT** /users/{user_id}/teams/{team_id}/threads/read | Mark all threads that user is following as read
*MattermostUploadsApi* | [**createUpload**](doc//MattermostUploadsApi.md#createupload) | **POST** /uploads | Create an upload
*MattermostUploadsApi* | [**getUpload**](doc//MattermostUploadsApi.md#getupload) | **GET** /uploads/{upload_id} | Get an upload session
*MattermostUploadsApi* | [**uploadData**](doc//MattermostUploadsApi.md#uploaddata) | **POST** /uploads/{upload_id} | Perform a file upload
*MattermostUsageApi* | [**getPostsUsage**](doc//MattermostUsageApi.md#getpostsusage) | **GET** /usage/posts | Get current usage of posts
*MattermostUsersApi* | [**attachDeviceId**](doc//MattermostUsersApi.md#attachdeviceid) | **PUT** /users/sessions/device | Attach mobile device
*MattermostUsersApi* | [**autocompleteUsers**](doc//MattermostUsersApi.md#autocompleteusers) | **GET** /users/autocomplete | Autocomplete users
*MattermostUsersApi* | [**checkUserMfa**](doc//MattermostUsersApi.md#checkusermfa) | **POST** /users/mfa | Check MFA
*MattermostUsersApi* | [**convertBotToUser**](doc//MattermostUsersApi.md#convertbottouser) | **POST** /bots/{bot_user_id}/convert_to_user | Convert a bot into a user
*MattermostUsersApi* | [**convertUserToBot**](doc//MattermostUsersApi.md#convertusertobot) | **POST** /users/{user_id}/convert_to_bot | Convert a user into a bot
*MattermostUsersApi* | [**createUser**](doc//MattermostUsersApi.md#createuser) | **POST** /users | Create a user
*MattermostUsersApi* | [**createUserAccessToken**](doc//MattermostUsersApi.md#createuseraccesstoken) | **POST** /users/{user_id}/tokens | Create a user access token
*MattermostUsersApi* | [**deleteUser**](doc//MattermostUsersApi.md#deleteuser) | **DELETE** /users/{user_id} | Deactivate a user account.
*MattermostUsersApi* | [**demoteUserToGuest**](doc//MattermostUsersApi.md#demoteusertoguest) | **POST** /users/{user_id}/demote | Demote a user to a guest
*MattermostUsersApi* | [**disableUserAccessToken**](doc//MattermostUsersApi.md#disableuseraccesstoken) | **POST** /users/tokens/disable | Disable personal access token
*MattermostUsersApi* | [**enableUserAccessToken**](doc//MattermostUsersApi.md#enableuseraccesstoken) | **POST** /users/tokens/enable | Enable personal access token
*MattermostUsersApi* | [**generateMfaSecret**](doc//MattermostUsersApi.md#generatemfasecret) | **POST** /users/{user_id}/mfa/generate | Generate MFA secret
*MattermostUsersApi* | [**getChannelMembersWithTeamDataForUser**](doc//MattermostUsersApi.md#getchannelmemberswithteamdataforuser) | **GET** /users/{user_id}/channel_members | Get all channel members from all teams for a user
*MattermostUsersApi* | [**getDefaultProfileImage**](doc//MattermostUsersApi.md#getdefaultprofileimage) | **GET** /users/{user_id}/image/default | Return user's default (generated) profile image
*MattermostUsersApi* | [**getKnownUsers**](doc//MattermostUsersApi.md#getknownusers) | **GET** /users/known | Get user IDs of known users
*MattermostUsersApi* | [**getProfileImage**](doc//MattermostUsersApi.md#getprofileimage) | **GET** /users/{user_id}/image | Get user's profile image
*MattermostUsersApi* | [**getSessions**](doc//MattermostUsersApi.md#getsessions) | **GET** /users/{user_id}/sessions | Get user's sessions
*MattermostUsersApi* | [**getTotalUsersStats**](doc//MattermostUsersApi.md#gettotalusersstats) | **GET** /users/stats | Get total count of users in the system
*MattermostUsersApi* | [**getTotalUsersStatsFiltered**](doc//MattermostUsersApi.md#gettotalusersstatsfiltered) | **GET** /users/stats/filtered | Get total count of users in the system matching the specified filters
*MattermostUsersApi* | [**getUploadsForUser**](doc//MattermostUsersApi.md#getuploadsforuser) | **GET** /users/{user_id}/uploads | Get uploads for a user
*MattermostUsersApi* | [**getUser**](doc//MattermostUsersApi.md#getuser) | **GET** /users/{user_id} | Get a user
*MattermostUsersApi* | [**getUserAccessToken**](doc//MattermostUsersApi.md#getuseraccesstoken) | **GET** /users/tokens/{token_id} | Get a user access token
*MattermostUsersApi* | [**getUserAccessTokens**](doc//MattermostUsersApi.md#getuseraccesstokens) | **GET** /users/tokens | Get user access tokens
*MattermostUsersApi* | [**getUserAccessTokensForUser**](doc//MattermostUsersApi.md#getuseraccesstokensforuser) | **GET** /users/{user_id}/tokens | Get user access tokens
*MattermostUsersApi* | [**getUserAudits**](doc//MattermostUsersApi.md#getuseraudits) | **GET** /users/{user_id}/audits | Get user's audits
*MattermostUsersApi* | [**getUserByEmail**](doc//MattermostUsersApi.md#getuserbyemail) | **GET** /users/email/{email} | Get a user by email
*MattermostUsersApi* | [**getUserByUsername**](doc//MattermostUsersApi.md#getuserbyusername) | **GET** /users/username/{username} | Get a user by username
*MattermostUsersApi* | [**getUserTermsOfService**](doc//MattermostUsersApi.md#getusertermsofservice) | **GET** /users/{user_id}/terms_of_service | Fetches user's latest terms of service action if the latest action was for acceptance.
*MattermostUsersApi* | [**getUsers**](doc//MattermostUsersApi.md#getusers) | **GET** /users | Get users
*MattermostUsersApi* | [**getUsersByGroupChannelIds**](doc//MattermostUsersApi.md#getusersbygroupchannelids) | **POST** /users/group_channels | Get users by group channels ids
*MattermostUsersApi* | [**getUsersByIds**](doc//MattermostUsersApi.md#getusersbyids) | **POST** /users/ids | Get users by ids
*MattermostUsersApi* | [**getUsersByUsernames**](doc//MattermostUsersApi.md#getusersbyusernames) | **POST** /users/usernames | Get users by usernames
*MattermostUsersApi* | [**login**](doc//MattermostUsersApi.md#login) | **POST** /users/login | Login to Mattermost server
*MattermostUsersApi* | [**loginByCwsToken**](doc//MattermostUsersApi.md#loginbycwstoken) | **POST** /users/login/cws | Auto-Login to Mattermost server using CWS token
*MattermostUsersApi* | [**logout**](doc//MattermostUsersApi.md#logout) | **POST** /users/logout | Logout from the Mattermost server
*MattermostUsersApi* | [**migrateAuthToLdap**](doc//MattermostUsersApi.md#migrateauthtoldap) | **POST** /users/migrate_auth/ldap | Migrate user accounts authentication type to LDAP.
*MattermostUsersApi* | [**migrateAuthToSaml**](doc//MattermostUsersApi.md#migrateauthtosaml) | **POST** /users/migrate_auth/saml | Migrate user accounts authentication type to SAML.
*MattermostUsersApi* | [**patchUser**](doc//MattermostUsersApi.md#patchuser) | **PUT** /users/{user_id}/patch | Patch a user
*MattermostUsersApi* | [**permanentDeleteAllUsers**](doc//MattermostUsersApi.md#permanentdeleteallusers) | **DELETE** /users | Permanent delete all users
*MattermostUsersApi* | [**promoteGuestToUser**](doc//MattermostUsersApi.md#promoteguesttouser) | **POST** /users/{user_id}/promote | Promote a guest to user
*MattermostUsersApi* | [**publishUserTyping**](doc//MattermostUsersApi.md#publishusertyping) | **POST** /users/{user_id}/typing | Publish a user typing websocket event.
*MattermostUsersApi* | [**registerTermsOfServiceAction**](doc//MattermostUsersApi.md#registertermsofserviceaction) | **POST** /users/{user_id}/terms_of_service | Records user action when they accept or decline custom terms of service
*MattermostUsersApi* | [**resetPassword**](doc//MattermostUsersApi.md#resetpassword) | **POST** /users/password/reset | Reset password
*MattermostUsersApi* | [**revokeAllSessions**](doc//MattermostUsersApi.md#revokeallsessions) | **POST** /users/{user_id}/sessions/revoke/all | Revoke all active sessions for a user
*MattermostUsersApi* | [**revokeSession**](doc//MattermostUsersApi.md#revokesession) | **POST** /users/{user_id}/sessions/revoke | Revoke a user session
*MattermostUsersApi* | [**revokeSessionsFromAllUsers**](doc//MattermostUsersApi.md#revokesessionsfromallusers) | **POST** /users/sessions/revoke/all | Revoke all sessions from all users.
*MattermostUsersApi* | [**revokeUserAccessToken**](doc//MattermostUsersApi.md#revokeuseraccesstoken) | **POST** /users/tokens/revoke | Revoke a user access token
*MattermostUsersApi* | [**searchUserAccessTokens**](doc//MattermostUsersApi.md#searchuseraccesstokens) | **POST** /users/tokens/search | Search tokens
*MattermostUsersApi* | [**searchUsers**](doc//MattermostUsersApi.md#searchusers) | **POST** /users/search | Search users
*MattermostUsersApi* | [**sendPasswordResetEmail**](doc//MattermostUsersApi.md#sendpasswordresetemail) | **POST** /users/password/reset/send | Send password reset email
*MattermostUsersApi* | [**sendVerificationEmail**](doc//MattermostUsersApi.md#sendverificationemail) | **POST** /users/email/verify/send | Send verification email
*MattermostUsersApi* | [**setDefaultProfileImage**](doc//MattermostUsersApi.md#setdefaultprofileimage) | **DELETE** /users/{user_id}/image | Delete user's profile image
*MattermostUsersApi* | [**setProfileImage**](doc//MattermostUsersApi.md#setprofileimage) | **POST** /users/{user_id}/image | Set user's profile image
*MattermostUsersApi* | [**switchAccountType**](doc//MattermostUsersApi.md#switchaccounttype) | **POST** /users/login/switch | Switch login method
*MattermostUsersApi* | [**updateUser**](doc//MattermostUsersApi.md#updateuser) | **PUT** /users/{user_id} | Update a user
*MattermostUsersApi* | [**updateUserActive**](doc//MattermostUsersApi.md#updateuseractive) | **PUT** /users/{user_id}/active | Update user active status
*MattermostUsersApi* | [**updateUserAuth**](doc//MattermostUsersApi.md#updateuserauth) | **PUT** /users/{user_id}/auth | Update a user's authentication method
*MattermostUsersApi* | [**updateUserMfa**](doc//MattermostUsersApi.md#updateusermfa) | **PUT** /users/{user_id}/mfa | Update a user's MFA
*MattermostUsersApi* | [**updateUserPassword**](doc//MattermostUsersApi.md#updateuserpassword) | **PUT** /users/{user_id}/password | Update a user's password
*MattermostUsersApi* | [**updateUserRoles**](doc//MattermostUsersApi.md#updateuserroles) | **PUT** /users/{user_id}/roles | Update a user's roles
*MattermostUsersApi* | [**verifyUserEmail**](doc//MattermostUsersApi.md#verifyuseremail) | **POST** /users/email/verify | Verify user email
*MattermostUsersApi* | [**verifyUserEmailWithoutToken**](doc//MattermostUsersApi.md#verifyuseremailwithouttoken) | **POST** /users/{user_id}/email/verify/member | Verify user email by ID
*MattermostWebhooksApi* | [**createIncomingWebhook**](doc//MattermostWebhooksApi.md#createincomingwebhook) | **POST** /hooks/incoming | Create an incoming webhook
*MattermostWebhooksApi* | [**createOutgoingWebhook**](doc//MattermostWebhooksApi.md#createoutgoingwebhook) | **POST** /hooks/outgoing | Create an outgoing webhook
*MattermostWebhooksApi* | [**deleteIncomingWebhook**](doc//MattermostWebhooksApi.md#deleteincomingwebhook) | **DELETE** /hooks/incoming/{hook_id} | Delete an incoming webhook
*MattermostWebhooksApi* | [**deleteOutgoingWebhook**](doc//MattermostWebhooksApi.md#deleteoutgoingwebhook) | **DELETE** /hooks/outgoing/{hook_id} | Delete an outgoing webhook
*MattermostWebhooksApi* | [**getIncomingWebhook**](doc//MattermostWebhooksApi.md#getincomingwebhook) | **GET** /hooks/incoming/{hook_id} | Get an incoming webhook
*MattermostWebhooksApi* | [**getIncomingWebhooks**](doc//MattermostWebhooksApi.md#getincomingwebhooks) | **GET** /hooks/incoming | List incoming webhooks
*MattermostWebhooksApi* | [**getOutgoingWebhook**](doc//MattermostWebhooksApi.md#getoutgoingwebhook) | **GET** /hooks/outgoing/{hook_id} | Get an outgoing webhook
*MattermostWebhooksApi* | [**getOutgoingWebhooks**](doc//MattermostWebhooksApi.md#getoutgoingwebhooks) | **GET** /hooks/outgoing | List outgoing webhooks
*MattermostWebhooksApi* | [**regenOutgoingHookToken**](doc//MattermostWebhooksApi.md#regenoutgoinghooktoken) | **POST** /hooks/outgoing/{hook_id}/regen_token | Regenerate the token for the outgoing webhook.
*MattermostWebhooksApi* | [**updateIncomingWebhook**](doc//MattermostWebhooksApi.md#updateincomingwebhook) | **PUT** /hooks/incoming/{hook_id} | Update an incoming webhook
*MattermostWebhooksApi* | [**updateOutgoingWebhook**](doc//MattermostWebhooksApi.md#updateoutgoingwebhook) | **PUT** /hooks/outgoing/{hook_id} | Update an outgoing webhook


## Documentation For Models

 - [MattermostAddChannelMemberRequest](doc//MattermostAddChannelMemberRequest.md)
 - [MattermostAddGroupMembersRequest](doc//MattermostAddGroupMembersRequest.md)
 - [MattermostAddOn](doc//MattermostAddOn.md)
 - [MattermostAddTeamMemberRequest](doc//MattermostAddTeamMemberRequest.md)
 - [MattermostAddress](doc//MattermostAddress.md)
 - [MattermostAppError](doc//MattermostAppError.md)
 - [MattermostAttachDeviceIdRequest](doc//MattermostAttachDeviceIdRequest.md)
 - [MattermostAudit](doc//MattermostAudit.md)
 - [MattermostAutocompleteSuggestion](doc//MattermostAutocompleteSuggestion.md)
 - [MattermostBoardsLimits](doc//MattermostBoardsLimits.md)
 - [MattermostBot](doc//MattermostBot.md)
 - [MattermostChannel](doc//MattermostChannel.md)
 - [MattermostChannelData](doc//MattermostChannelData.md)
 - [MattermostChannelMember](doc//MattermostChannelMember.md)
 - [MattermostChannelMemberCountByGroup](doc//MattermostChannelMemberCountByGroup.md)
 - [MattermostChannelMemberWithTeamData](doc//MattermostChannelMemberWithTeamData.md)
 - [MattermostChannelMemberWithTeamDataAllOf](doc//MattermostChannelMemberWithTeamDataAllOf.md)
 - [MattermostChannelModeratedRole](doc//MattermostChannelModeratedRole.md)
 - [MattermostChannelModeratedRoles](doc//MattermostChannelModeratedRoles.md)
 - [MattermostChannelModeratedRolesPatch](doc//MattermostChannelModeratedRolesPatch.md)
 - [MattermostChannelModeration](doc//MattermostChannelModeration.md)
 - [MattermostChannelModerationPatch](doc//MattermostChannelModerationPatch.md)
 - [MattermostChannelNotifyProps](doc//MattermostChannelNotifyProps.md)
 - [MattermostChannelStats](doc//MattermostChannelStats.md)
 - [MattermostChannelUnread](doc//MattermostChannelUnread.md)
 - [MattermostChannelUnreadAt](doc//MattermostChannelUnreadAt.md)
 - [MattermostChannelWithTeamData](doc//MattermostChannelWithTeamData.md)
 - [MattermostChannelWithTeamDataAllOf](doc//MattermostChannelWithTeamDataAllOf.md)
 - [MattermostCheckUserMfa200Response](doc//MattermostCheckUserMfa200Response.md)
 - [MattermostCheckUserMfaRequest](doc//MattermostCheckUserMfaRequest.md)
 - [MattermostCloudCustomer](doc//MattermostCloudCustomer.md)
 - [MattermostClusterInfo](doc//MattermostClusterInfo.md)
 - [MattermostCommand](doc//MattermostCommand.md)
 - [MattermostCommandResponse](doc//MattermostCommandResponse.md)
 - [MattermostCompliance](doc//MattermostCompliance.md)
 - [MattermostConfig](doc//MattermostConfig.md)
 - [MattermostConfigAnalyticsSettings](doc//MattermostConfigAnalyticsSettings.md)
 - [MattermostConfigClusterSettings](doc//MattermostConfigClusterSettings.md)
 - [MattermostConfigComplianceSettings](doc//MattermostConfigComplianceSettings.md)
 - [MattermostConfigEmailSettings](doc//MattermostConfigEmailSettings.md)
 - [MattermostConfigFileSettings](doc//MattermostConfigFileSettings.md)
 - [MattermostConfigGitLabSettings](doc//MattermostConfigGitLabSettings.md)
 - [MattermostConfigLdapSettings](doc//MattermostConfigLdapSettings.md)
 - [MattermostConfigLocalizationSettings](doc//MattermostConfigLocalizationSettings.md)
 - [MattermostConfigLogSettings](doc//MattermostConfigLogSettings.md)
 - [MattermostConfigMetricsSettings](doc//MattermostConfigMetricsSettings.md)
 - [MattermostConfigNativeAppSettings](doc//MattermostConfigNativeAppSettings.md)
 - [MattermostConfigPasswordSettings](doc//MattermostConfigPasswordSettings.md)
 - [MattermostConfigPrivacySettings](doc//MattermostConfigPrivacySettings.md)
 - [MattermostConfigRateLimitSettings](doc//MattermostConfigRateLimitSettings.md)
 - [MattermostConfigSamlSettings](doc//MattermostConfigSamlSettings.md)
 - [MattermostConfigServiceSettings](doc//MattermostConfigServiceSettings.md)
 - [MattermostConfigSqlSettings](doc//MattermostConfigSqlSettings.md)
 - [MattermostConfigSupportSettings](doc//MattermostConfigSupportSettings.md)
 - [MattermostConfigTeamSettings](doc//MattermostConfigTeamSettings.md)
 - [MattermostConvertBotToUserRequest](doc//MattermostConvertBotToUserRequest.md)
 - [MattermostCreateBotRequest](doc//MattermostCreateBotRequest.md)
 - [MattermostCreateChannelRequest](doc//MattermostCreateChannelRequest.md)
 - [MattermostCreateCommandRequest](doc//MattermostCreateCommandRequest.md)
 - [MattermostCreateGroupRequest](doc//MattermostCreateGroupRequest.md)
 - [MattermostCreateGroupRequestGroup](doc//MattermostCreateGroupRequestGroup.md)
 - [MattermostCreateIncomingWebhookRequest](doc//MattermostCreateIncomingWebhookRequest.md)
 - [MattermostCreateJobRequest](doc//MattermostCreateJobRequest.md)
 - [MattermostCreateOAuthAppRequest](doc//MattermostCreateOAuthAppRequest.md)
 - [MattermostCreateOutgoingWebhookRequest](doc//MattermostCreateOutgoingWebhookRequest.md)
 - [MattermostCreatePostEphemeralRequest](doc//MattermostCreatePostEphemeralRequest.md)
 - [MattermostCreatePostEphemeralRequestPost](doc//MattermostCreatePostEphemeralRequestPost.md)
 - [MattermostCreatePostRequest](doc//MattermostCreatePostRequest.md)
 - [MattermostCreateSchemeRequest](doc//MattermostCreateSchemeRequest.md)
 - [MattermostCreateTeamRequest](doc//MattermostCreateTeamRequest.md)
 - [MattermostCreateUploadRequest](doc//MattermostCreateUploadRequest.md)
 - [MattermostCreateUserAccessTokenRequest](doc//MattermostCreateUserAccessTokenRequest.md)
 - [MattermostCreateUserRequest](doc//MattermostCreateUserRequest.md)
 - [MattermostDataRetentionPolicy](doc//MattermostDataRetentionPolicy.md)
 - [MattermostDataRetentionPolicyAllOf](doc//MattermostDataRetentionPolicyAllOf.md)
 - [MattermostDataRetentionPolicyCreate](doc//MattermostDataRetentionPolicyCreate.md)
 - [MattermostDataRetentionPolicyForChannel](doc//MattermostDataRetentionPolicyForChannel.md)
 - [MattermostDataRetentionPolicyForTeam](doc//MattermostDataRetentionPolicyForTeam.md)
 - [MattermostDataRetentionPolicyWithTeamAndChannelCounts](doc//MattermostDataRetentionPolicyWithTeamAndChannelCounts.md)
 - [MattermostDataRetentionPolicyWithTeamAndChannelCountsAllOf](doc//MattermostDataRetentionPolicyWithTeamAndChannelCountsAllOf.md)
 - [MattermostDataRetentionPolicyWithTeamAndChannelIds](doc//MattermostDataRetentionPolicyWithTeamAndChannelIds.md)
 - [MattermostDataRetentionPolicyWithTeamAndChannelIdsAllOf](doc//MattermostDataRetentionPolicyWithTeamAndChannelIdsAllOf.md)
 - [MattermostDataRetentionPolicyWithoutId](doc//MattermostDataRetentionPolicyWithoutId.md)
 - [MattermostDeleteGroupMembersRequest](doc//MattermostDeleteGroupMembersRequest.md)
 - [MattermostDisableUserAccessTokenRequest](doc//MattermostDisableUserAccessTokenRequest.md)
 - [MattermostEmoji](doc//MattermostEmoji.md)
 - [MattermostEnableUserAccessTokenRequest](doc//MattermostEnableUserAccessTokenRequest.md)
 - [MattermostEnvironmentConfig](doc//MattermostEnvironmentConfig.md)
 - [MattermostEnvironmentConfigAnalyticsSettings](doc//MattermostEnvironmentConfigAnalyticsSettings.md)
 - [MattermostEnvironmentConfigClusterSettings](doc//MattermostEnvironmentConfigClusterSettings.md)
 - [MattermostEnvironmentConfigComplianceSettings](doc//MattermostEnvironmentConfigComplianceSettings.md)
 - [MattermostEnvironmentConfigEmailSettings](doc//MattermostEnvironmentConfigEmailSettings.md)
 - [MattermostEnvironmentConfigFileSettings](doc//MattermostEnvironmentConfigFileSettings.md)
 - [MattermostEnvironmentConfigGitLabSettings](doc//MattermostEnvironmentConfigGitLabSettings.md)
 - [MattermostEnvironmentConfigLdapSettings](doc//MattermostEnvironmentConfigLdapSettings.md)
 - [MattermostEnvironmentConfigLocalizationSettings](doc//MattermostEnvironmentConfigLocalizationSettings.md)
 - [MattermostEnvironmentConfigLogSettings](doc//MattermostEnvironmentConfigLogSettings.md)
 - [MattermostEnvironmentConfigMetricsSettings](doc//MattermostEnvironmentConfigMetricsSettings.md)
 - [MattermostEnvironmentConfigNativeAppSettings](doc//MattermostEnvironmentConfigNativeAppSettings.md)
 - [MattermostEnvironmentConfigPasswordSettings](doc//MattermostEnvironmentConfigPasswordSettings.md)
 - [MattermostEnvironmentConfigRateLimitSettings](doc//MattermostEnvironmentConfigRateLimitSettings.md)
 - [MattermostEnvironmentConfigSamlSettings](doc//MattermostEnvironmentConfigSamlSettings.md)
 - [MattermostEnvironmentConfigServiceSettings](doc//MattermostEnvironmentConfigServiceSettings.md)
 - [MattermostEnvironmentConfigSqlSettings](doc//MattermostEnvironmentConfigSqlSettings.md)
 - [MattermostEnvironmentConfigSupportSettings](doc//MattermostEnvironmentConfigSupportSettings.md)
 - [MattermostEnvironmentConfigTeamSettings](doc//MattermostEnvironmentConfigTeamSettings.md)
 - [MattermostExecuteCommandRequest](doc//MattermostExecuteCommandRequest.md)
 - [MattermostFileInfo](doc//MattermostFileInfo.md)
 - [MattermostFileInfoList](doc//MattermostFileInfoList.md)
 - [MattermostFilesLimits](doc//MattermostFilesLimits.md)
 - [MattermostGenerateMfaSecret200Response](doc//MattermostGenerateMfaSecret200Response.md)
 - [MattermostGetDataRetentionPoliciesCount200Response](doc//MattermostGetDataRetentionPoliciesCount200Response.md)
 - [MattermostGetFileLink200Response](doc//MattermostGetFileLink200Response.md)
 - [MattermostGetGroupStats200Response](doc//MattermostGetGroupStats200Response.md)
 - [MattermostGetGroupUsers200Response](doc//MattermostGetGroupUsers200Response.md)
 - [MattermostGetPlugins200Response](doc//MattermostGetPlugins200Response.md)
 - [MattermostGetRedirectLocation200Response](doc//MattermostGetRedirectLocation200Response.md)
 - [MattermostGetSamlMetadataFromIdpRequest](doc//MattermostGetSamlMetadataFromIdpRequest.md)
 - [MattermostGetTeamInviteInfo200Response](doc//MattermostGetTeamInviteInfo200Response.md)
 - [MattermostGetUsersByGroupChannelIds200Response](doc//MattermostGetUsersByGroupChannelIds200Response.md)
 - [MattermostGlobalDataRetentionPolicy](doc//MattermostGlobalDataRetentionPolicy.md)
 - [MattermostGroup](doc//MattermostGroup.md)
 - [MattermostGroupSyncableChannel](doc//MattermostGroupSyncableChannel.md)
 - [MattermostGroupSyncableChannels](doc//MattermostGroupSyncableChannels.md)
 - [MattermostGroupSyncableTeam](doc//MattermostGroupSyncableTeam.md)
 - [MattermostGroupSyncableTeams](doc//MattermostGroupSyncableTeams.md)
 - [MattermostGroupWithSchemeAdmin](doc//MattermostGroupWithSchemeAdmin.md)
 - [MattermostImportTeam200Response](doc//MattermostImportTeam200Response.md)
 - [MattermostIncomingWebhook](doc//MattermostIncomingWebhook.md)
 - [MattermostInstallMarketplacePluginRequest](doc//MattermostInstallMarketplacePluginRequest.md)
 - [MattermostIntegrationsLimits](doc//MattermostIntegrationsLimits.md)
 - [MattermostIntegrityCheckResult](doc//MattermostIntegrityCheckResult.md)
 - [MattermostInviteGuestsToTeamRequest](doc//MattermostInviteGuestsToTeamRequest.md)
 - [MattermostInvoice](doc//MattermostInvoice.md)
 - [MattermostInvoiceLineItem](doc//MattermostInvoiceLineItem.md)
 - [MattermostJob](doc//MattermostJob.md)
 - [MattermostLDAPGroup](doc//MattermostLDAPGroup.md)
 - [MattermostLDAPGroupsPaged](doc//MattermostLDAPGroupsPaged.md)
 - [MattermostLicenseRenewalLink](doc//MattermostLicenseRenewalLink.md)
 - [MattermostLoginByCwsTokenRequest](doc//MattermostLoginByCwsTokenRequest.md)
 - [MattermostLoginRequest](doc//MattermostLoginRequest.md)
 - [MattermostMarketplacePlugin](doc//MattermostMarketplacePlugin.md)
 - [MattermostMessagesLimits](doc//MattermostMessagesLimits.md)
 - [MattermostMigrateAuthToLdapRequest](doc//MattermostMigrateAuthToLdapRequest.md)
 - [MattermostMigrateAuthToSamlRequest](doc//MattermostMigrateAuthToSamlRequest.md)
 - [MattermostMigrateIdLdapRequest](doc//MattermostMigrateIdLdapRequest.md)
 - [MattermostMoveChannelRequest](doc//MattermostMoveChannelRequest.md)
 - [MattermostMoveCommandRequest](doc//MattermostMoveCommandRequest.md)
 - [MattermostNotice](doc//MattermostNotice.md)
 - [MattermostOAuthApp](doc//MattermostOAuthApp.md)
 - [MattermostOpenGraph](doc//MattermostOpenGraph.md)
 - [MattermostOpenGraphArticle](doc//MattermostOpenGraphArticle.md)
 - [MattermostOpenGraphArticleAuthorsInner](doc//MattermostOpenGraphArticleAuthorsInner.md)
 - [MattermostOpenGraphAudiosInner](doc//MattermostOpenGraphAudiosInner.md)
 - [MattermostOpenGraphBook](doc//MattermostOpenGraphBook.md)
 - [MattermostOpenGraphImagesInner](doc//MattermostOpenGraphImagesInner.md)
 - [MattermostOpenGraphRequest](doc//MattermostOpenGraphRequest.md)
 - [MattermostOpenGraphVideosInner](doc//MattermostOpenGraphVideosInner.md)
 - [MattermostOpenInteractiveDialogRequest](doc//MattermostOpenInteractiveDialogRequest.md)
 - [MattermostOpenInteractiveDialogRequestDialog](doc//MattermostOpenInteractiveDialogRequestDialog.md)
 - [MattermostOrderedSidebarCategories](doc//MattermostOrderedSidebarCategories.md)
 - [MattermostOrphanedRecord](doc//MattermostOrphanedRecord.md)
 - [MattermostOutgoingWebhook](doc//MattermostOutgoingWebhook.md)
 - [MattermostPatchChannelRequest](doc//MattermostPatchChannelRequest.md)
 - [MattermostPatchGroupRequest](doc//MattermostPatchGroupRequest.md)
 - [MattermostPatchGroupSyncableForTeamRequest](doc//MattermostPatchGroupSyncableForTeamRequest.md)
 - [MattermostPatchPostRequest](doc//MattermostPatchPostRequest.md)
 - [MattermostPatchRoleRequest](doc//MattermostPatchRoleRequest.md)
 - [MattermostPatchSchemeRequest](doc//MattermostPatchSchemeRequest.md)
 - [MattermostPatchTeamRequest](doc//MattermostPatchTeamRequest.md)
 - [MattermostPatchUserRequest](doc//MattermostPatchUserRequest.md)
 - [MattermostPaymentMethod](doc//MattermostPaymentMethod.md)
 - [MattermostPaymentSetupIntent](doc//MattermostPaymentSetupIntent.md)
 - [MattermostPluginManifest](doc//MattermostPluginManifest.md)
 - [MattermostPluginManifestBackend](doc//MattermostPluginManifestBackend.md)
 - [MattermostPluginManifestServer](doc//MattermostPluginManifestServer.md)
 - [MattermostPluginManifestServerExecutables](doc//MattermostPluginManifestServerExecutables.md)
 - [MattermostPluginManifestWebapp](doc//MattermostPluginManifestWebapp.md)
 - [MattermostPluginStatus](doc//MattermostPluginStatus.md)
 - [MattermostPost](doc//MattermostPost.md)
 - [MattermostPostList](doc//MattermostPostList.md)
 - [MattermostPostListWithSearchMatches](doc//MattermostPostListWithSearchMatches.md)
 - [MattermostPostLogRequest](doc//MattermostPostLogRequest.md)
 - [MattermostPostMetadata](doc//MattermostPostMetadata.md)
 - [MattermostPostMetadataEmbedsInner](doc//MattermostPostMetadataEmbedsInner.md)
 - [MattermostPostMetadataImagesInner](doc//MattermostPostMetadataImagesInner.md)
 - [MattermostPostsUsage](doc//MattermostPostsUsage.md)
 - [MattermostPreference](doc//MattermostPreference.md)
 - [MattermostProduct](doc//MattermostProduct.md)
 - [MattermostProductLimits](doc//MattermostProductLimits.md)
 - [MattermostPublishUserTypingRequest](doc//MattermostPublishUserTypingRequest.md)
 - [MattermostPushNotification](doc//MattermostPushNotification.md)
 - [MattermostReaction](doc//MattermostReaction.md)
 - [MattermostRegenCommandToken200Response](doc//MattermostRegenCommandToken200Response.md)
 - [MattermostRegisterTermsOfServiceActionRequest](doc//MattermostRegisterTermsOfServiceActionRequest.md)
 - [MattermostRelationalIntegrityCheckData](doc//MattermostRelationalIntegrityCheckData.md)
 - [MattermostRemoteClusterInfo](doc//MattermostRemoteClusterInfo.md)
 - [MattermostRemoveRecentCustomStatusRequest](doc//MattermostRemoveRecentCustomStatusRequest.md)
 - [MattermostRequestTrialLicenseRequest](doc//MattermostRequestTrialLicenseRequest.md)
 - [MattermostResetPasswordRequest](doc//MattermostResetPasswordRequest.md)
 - [MattermostResetSamlAuthDataToEmail200Response](doc//MattermostResetSamlAuthDataToEmail200Response.md)
 - [MattermostResetSamlAuthDataToEmailRequest](doc//MattermostResetSamlAuthDataToEmailRequest.md)
 - [MattermostRetentionPolicyForChannelList](doc//MattermostRetentionPolicyForChannelList.md)
 - [MattermostRetentionPolicyForTeamList](doc//MattermostRetentionPolicyForTeamList.md)
 - [MattermostRevokeSessionRequest](doc//MattermostRevokeSessionRequest.md)
 - [MattermostRevokeUserAccessTokenRequest](doc//MattermostRevokeUserAccessTokenRequest.md)
 - [MattermostRole](doc//MattermostRole.md)
 - [MattermostSamlCertificateStatus](doc//MattermostSamlCertificateStatus.md)
 - [MattermostScheme](doc//MattermostScheme.md)
 - [MattermostSearchAllChannels200Response](doc//MattermostSearchAllChannels200Response.md)
 - [MattermostSearchAllChannelsRequest](doc//MattermostSearchAllChannelsRequest.md)
 - [MattermostSearchArchivedChannelsRequest](doc//MattermostSearchArchivedChannelsRequest.md)
 - [MattermostSearchChannelsForRetentionPolicyRequest](doc//MattermostSearchChannelsForRetentionPolicyRequest.md)
 - [MattermostSearchChannelsRequest](doc//MattermostSearchChannelsRequest.md)
 - [MattermostSearchEmojiRequest](doc//MattermostSearchEmojiRequest.md)
 - [MattermostSearchGroupChannelsRequest](doc//MattermostSearchGroupChannelsRequest.md)
 - [MattermostSearchPostsRequest](doc//MattermostSearchPostsRequest.md)
 - [MattermostSearchTeams200Response](doc//MattermostSearchTeams200Response.md)
 - [MattermostSearchTeamsForRetentionPolicyRequest](doc//MattermostSearchTeamsForRetentionPolicyRequest.md)
 - [MattermostSearchTeamsRequest](doc//MattermostSearchTeamsRequest.md)
 - [MattermostSearchUserAccessTokensRequest](doc//MattermostSearchUserAccessTokensRequest.md)
 - [MattermostSearchUsersRequest](doc//MattermostSearchUsersRequest.md)
 - [MattermostSendPasswordResetEmailRequest](doc//MattermostSendPasswordResetEmailRequest.md)
 - [MattermostSendVerificationEmailRequest](doc//MattermostSendVerificationEmailRequest.md)
 - [MattermostSendWarnMetricAckRequest](doc//MattermostSendWarnMetricAckRequest.md)
 - [MattermostServerBusy](doc//MattermostServerBusy.md)
 - [MattermostSession](doc//MattermostSession.md)
 - [MattermostSharedChannel](doc//MattermostSharedChannel.md)
 - [MattermostSidebarCategory](doc//MattermostSidebarCategory.md)
 - [MattermostSidebarCategoryWithChannels](doc//MattermostSidebarCategoryWithChannels.md)
 - [MattermostSlackAttachment](doc//MattermostSlackAttachment.md)
 - [MattermostSlackAttachmentField](doc//MattermostSlackAttachmentField.md)
 - [MattermostStatus](doc//MattermostStatus.md)
 - [MattermostStatusOK](doc//MattermostStatusOK.md)
 - [MattermostSubmitInteractiveDialogRequest](doc//MattermostSubmitInteractiveDialogRequest.md)
 - [MattermostSubscription](doc//MattermostSubscription.md)
 - [MattermostSubscriptionStats](doc//MattermostSubscriptionStats.md)
 - [MattermostSwitchAccountType200Response](doc//MattermostSwitchAccountType200Response.md)
 - [MattermostSwitchAccountTypeRequest](doc//MattermostSwitchAccountTypeRequest.md)
 - [MattermostSystem](doc//MattermostSystem.md)
 - [MattermostSystemStatusResponse](doc//MattermostSystemStatusResponse.md)
 - [MattermostTeam](doc//MattermostTeam.md)
 - [MattermostTeamExists](doc//MattermostTeamExists.md)
 - [MattermostTeamMap](doc//MattermostTeamMap.md)
 - [MattermostTeamMember](doc//MattermostTeamMember.md)
 - [MattermostTeamStats](doc//MattermostTeamStats.md)
 - [MattermostTeamUnread](doc//MattermostTeamUnread.md)
 - [MattermostTeamsLimits](doc//MattermostTeamsLimits.md)
 - [MattermostTermsOfService](doc//MattermostTermsOfService.md)
 - [MattermostTestSiteURLRequest](doc//MattermostTestSiteURLRequest.md)
 - [MattermostTimezone](doc//MattermostTimezone.md)
 - [MattermostTopChannel](doc//MattermostTopChannel.md)
 - [MattermostTopChannelList](doc//MattermostTopChannelList.md)
 - [MattermostTopReaction](doc//MattermostTopReaction.md)
 - [MattermostTopReactionList](doc//MattermostTopReactionList.md)
 - [MattermostUpdateChannelPrivacyRequest](doc//MattermostUpdateChannelPrivacyRequest.md)
 - [MattermostUpdateChannelRequest](doc//MattermostUpdateChannelRequest.md)
 - [MattermostUpdateCloudCustomerRequest](doc//MattermostUpdateCloudCustomerRequest.md)
 - [MattermostUpdateIncomingWebhookRequest](doc//MattermostUpdateIncomingWebhookRequest.md)
 - [MattermostUpdateOAuthAppRequest](doc//MattermostUpdateOAuthAppRequest.md)
 - [MattermostUpdateOutgoingWebhookRequest](doc//MattermostUpdateOutgoingWebhookRequest.md)
 - [MattermostUpdatePostRequest](doc//MattermostUpdatePostRequest.md)
 - [MattermostUpdateTeamMemberSchemeRolesRequest](doc//MattermostUpdateTeamMemberSchemeRolesRequest.md)
 - [MattermostUpdateTeamPrivacyRequest](doc//MattermostUpdateTeamPrivacyRequest.md)
 - [MattermostUpdateTeamRequest](doc//MattermostUpdateTeamRequest.md)
 - [MattermostUpdateTeamSchemeRequest](doc//MattermostUpdateTeamSchemeRequest.md)
 - [MattermostUpdateUserActiveRequest](doc//MattermostUpdateUserActiveRequest.md)
 - [MattermostUpdateUserCustomStatusRequest](doc//MattermostUpdateUserCustomStatusRequest.md)
 - [MattermostUpdateUserMfaRequest](doc//MattermostUpdateUserMfaRequest.md)
 - [MattermostUpdateUserPasswordRequest](doc//MattermostUpdateUserPasswordRequest.md)
 - [MattermostUpdateUserRequest](doc//MattermostUpdateUserRequest.md)
 - [MattermostUpdateUserRolesRequest](doc//MattermostUpdateUserRolesRequest.md)
 - [MattermostUpdateUserStatusRequest](doc//MattermostUpdateUserStatusRequest.md)
 - [MattermostUpgradeToEnterpriseStatus200Response](doc//MattermostUpgradeToEnterpriseStatus200Response.md)
 - [MattermostUploadFile201Response](doc//MattermostUploadFile201Response.md)
 - [MattermostUploadSession](doc//MattermostUploadSession.md)
 - [MattermostUser](doc//MattermostUser.md)
 - [MattermostUserAccessToken](doc//MattermostUserAccessToken.md)
 - [MattermostUserAccessTokenSanitized](doc//MattermostUserAccessTokenSanitized.md)
 - [MattermostUserAuthData](doc//MattermostUserAuthData.md)
 - [MattermostUserAutocomplete](doc//MattermostUserAutocomplete.md)
 - [MattermostUserAutocompleteInChannel](doc//MattermostUserAutocompleteInChannel.md)
 - [MattermostUserAutocompleteInTeam](doc//MattermostUserAutocompleteInTeam.md)
 - [MattermostUserNotifyProps](doc//MattermostUserNotifyProps.md)
 - [MattermostUserTermsOfService](doc//MattermostUserTermsOfService.md)
 - [MattermostUserThread](doc//MattermostUserThread.md)
 - [MattermostUserThreads](doc//MattermostUserThreads.md)
 - [MattermostUsersStats](doc//MattermostUsersStats.md)
 - [MattermostVerifyUserEmailRequest](doc//MattermostVerifyUserEmailRequest.md)
 - [MattermostViewChannel200Response](doc//MattermostViewChannel200Response.md)
 - [MattermostViewChannelRequest](doc//MattermostViewChannelRequest.md)


## Documentation For Authorization


## bearerAuth

- **Type**: HTTP Bearer authentication


## Author

feedback@mattermost.com

